pro findtrend

;	Idl pro to find a trend image from a reference file
;	and output that trend file to a file called "trendimage"
;	Then this file can be subtracted from a bunch of images
;
;	Call this using idl batch mode
;		idl find_trend
;   will call findtrend.pro to find the trend image.
;
str = getenv('XDIM')
reads,str,xdim
str = getenv('YDIM')
reads,str,ydim
print,xdim,ydim
if ( xdim eq 0 ) then  xdim = 767
if ( ydim eq 0 ) then  ydim = 516

xcen = (xdim-1)/2
ycen = (ydim-1)/2
rad = (.75*ydim)/2.
band = 64
img=intarr(xdim,ydim)
fit=intarr(xdim,ydim)
openr,1,'idlimage'
readu,1,img
close,1
c=intarr(2*rad+1)
d=c
x = d
cfit = c
dfit = d

for i=-rad,rad do c(i+rad)=max(img(i+xcen,ycen-band:ycen+band))
for i=-rad,+rad do d(i+rad)=max(img(xcen-band:xcen+band,i+ycen))
for i=-rad,+rad do x(i+rad)=i
plot,x,c,yrange=[min(c),max(c)],psym=1
oplot,x,d,psym=2
ccoeff = poly_fit(x,c,1,cfit)
dcoeff = poly_fit(x,d,1,dfit)
print,ccoeff(0),ccoeff(1)
print,dcoeff(0),dcoeff(1)
oplot,x,cfit
oplot,x,dfit

;tvscl,img
for i=0,xdim-1 do begin
	x = i-xcen+rad
	if ( x lt 0 ) then x=0
	if ( x gt 2*rad ) then x=2*rad
	xfit=cfit(x)-ccoeff(0)
	for j=0,ydim-1 do begin
		y=j-ycen+rad
		if ( y lt 0 ) then y=0
		if ( y gt 2*rad ) then y=2*rad
		yfit=dfit(y)-dcoeff(0)
		fit(i,j)=img(i,j)-xfit-yfit
	end
end

tvscl,img-fit
openw,1,'trendimage'
writeu,1,img-fit
close,1

end

