/*
		accumulate filelist > accumulated_file

		This program reads a list of files
		It reads in each of these files and
		accumulates them.
		The accumulated file is sent to stdout.
*/


#include		<stdio.h>
#include		<stdlib.h>
#include		<errno.h>
#include		<fcntl.h>
#include		"dim.h"

main(argc,argv)
char		**argv;
int		argc;
{
FILE		*accumlist;
char		filename[80],*p;
short		*img;
int			fdimg,i,j,k,code,read(),write();
float		*accum,numimg;
register	float	*ap,ftemp;
register	short	*ip,stemp;

int			nrow,ncol,record;

sscanf ( getenv ( "XDIM" ),"%d",&ncol );
sscanf ( getenv ( "YDIM" ),"%d",&nrow );
record = 2*ncol;
if ( ncol == 0 ) 
	{
	ncol = NCOL;
	nrow = NROW;
	record = RECORD;
	}
img = (short*)malloc ( (size_t)(2*ncol*nrow) );
accum = (float*)malloc ( (size_t)(4*ncol*nrow) );
/*fprintf ( stderr,"%d %d\n",ncol,nrow );*/

if ( argc == 2 )
	{
	p = *++argv;
	if ( ( accumlist = fopen ( p,"r" ) ) < (FILE*)0 )
		{
		fprintf ( stderr," open error %d %s\n",accumlist,p );
		goto usage;
		}
	}
else
	goto usage;

/* Loop through all the file names in accumlist */
/* open the file named there and sum into a float */
/* Normalize by the number of images read */
ap = accum;
for ( i=0 ; i<sizeof(accum) ; i++ )
	*ap++ = 0.;

code = 0;
for ( k=0 ; feof(accumlist) == 0 ; k++ )
	{
	fscanf ( accumlist,"%s\n",filename );
	fdimg = open ( filename,O_RDONLY );
/*	fprintf ( stderr,"%s\n",filename ); */
	code = read ( fdimg,img,nrow*record );
	ip = img;
	ap = accum;
	for ( j=0 ; j<nrow ; j++ )
		for (i=0; i<ncol ; i++ )
			{
			stemp = *ip;
			ftemp = stemp;
			*ap += ftemp;
			ip++;
			ap++;
			}
	}
numimg = (float)k;
fprintf ( stderr,"%3.0f images \n",numimg );

ap = accum;
ip = img;
for ( j=0 ; j<nrow ; j++ )
	for (i=0; i<ncol ; i++ )
		{
		ftemp = *ap/numimg;
		ftemp = ftemp + (float)0.5 ;
		stemp = ftemp;
		*ip = stemp;
		ip++;
		ap++;
		}

write ( 1,img,record*nrow);

fclose ( accumlist );

exit ( 0 );

usage:
	fprintf (stderr, "accumulate filelist >accumulated_image\n" );
	exit (-1);

}

