/*
		disk del_diam shiftfile > outfile
		
		A filter to draw a disk at position given in file
		shiftfile with correction del_diam.

		shiftfile is a file containing the 
			xshift, yshift, and diam values (floats)

*/


#include		<stdio.h>
#include		<stdlib.h>
#include		<errno.h>
#include		<math.h>
#include		"dim.h"

main(argc,argv)
char		**argv;
int		argc;
{
FILE		*file;
void		doshift();
char		*p;
short		*img;
int			i,j,code,read(),write();
float		deldiam,xshi,yshi,diam;
float		rad,x,y,y2,xcen,ycen;
register	short	*ip;

int			nrow,ncol,record;

sscanf ( getenv ( "XDIM" ),"%d",&ncol );
sscanf ( getenv ( "YDIM" ),"%d",&nrow );
record = 2*ncol;
if ( ncol == 0 ) 
	{
	ncol = NCOL;
	nrow = NROW;
	record = RECORD;
	}
img = (short*)malloc ( (size_t)(2*ncol*nrow) );
/*fprintf ( stderr,"%d %d\n",ncol,nrow );*/

if ( argc == 3 )
	{
	p = *++argv;
	sscanf ( p,"%f",&deldiam);
	p = *++argv;
	fprintf ( stderr,"%s\n",p);
	if ( ( file = fopen ( p,"r" ) ) < (FILE*)0 )
		{
		fprintf ( stderr," open error %d %s\n",file,p );
		goto usage;
		}
	fscanf ( file,"%f %f %f",&xshi,&yshi,&diam );
	fprintf ( stderr,"%f %f %f\n",xshi,yshi,diam );
	}
else
	goto usage;

diam = diam + deldiam;			/* disk is too large otherwise */
xcen = (ncol-1.)/2. - xshi;
ycen = (nrow-1.)/2. - yshi;

rad = diam/2.;

ip = img;
for ( i=0; i<nrow ; i++ )
	{
	y = (float)i-ycen;
	y2 = y*y;
	for ( j=0 ; j<ncol ; j++ )
		{
		x = (float)j-xcen;
		if ( sqrt(x*x + y2) < rad )
			*ip++ = 10000;
		else
			*ip++ = 0;
		}
	}

if ( ( code = write ( 1,img,record*nrow ) ) != record*nrow )
	{
	fprintf ( stderr," write error %d \n",code );
	exit ( 1 );
	}

exit ( 0 );

usage:
	fprintf (stderr, "disk deldiam shiftfile out_image\n" );
	fprintf ( stderr, "shift file contains xshift, yshift, and diam\n");
	fprintf ( stderr, "deldiam (float) is a correction to diam.\n");
	exit (-1);

}

