/*
		norm_accumulate filelist > accumulated_file

		This program reads a list of files
		It reads in each of these files and
		accumulates them.
		Each image is normalized to an intensity
		level of 10000 for the center 64x64 pixels.

		The accumulated file is sent to stdout.
*/


#include		<stdio.h>
#include		<stdlib.h>
#include		<errno.h>
#include		<fcntl.h>
#include		"dim.h"

main(argc,argv)
char		**argv;
int		argc;
{
FILE		*accumlist;
char		filename[80],*p;
short		*img,stemp;
int			fdimg,i,j,k,code,read(),write();
int			xfirst,yfirst,xcen,ycen;
float		*accum,numimg,tot,ftemp;
register	float	*ap;
register	short	*ip;

int			nrow,ncol,record;

sscanf ( getenv ( "XDIM" ),"%d",&ncol );
sscanf ( getenv ( "YDIM" ),"%d",&nrow );
record = 2*ncol;
if ( ncol == 0 ) 
	{
	ncol = NCOL;
	nrow = NROW;
	record = RECORD;
	}
img = (short*)malloc ( (size_t)(2*ncol*nrow) );
accum = (float*)malloc ( (size_t)(4*ncol*nrow) );
/*fprintf ( stderr,"%d %d\n",ncol,nrow );*/


if ( argc == 2 )
	{
	p = *++argv;
	if ( ( accumlist = fopen ( p,"r" ) ) < (FILE*)0 )
		{
		fprintf ( stderr," open error %d %s\n",accumlist,p );
		goto usage;
		}
	}
else
	goto usage;

xcen = (ncol-1)/2;
ycen = (nrow -1)/2;
xfirst = xcen-32;
yfirst = ycen-32;

/* Loop through all the file names in accumlist */
/* open the file named there and sum into a float */
/* Normalize by the number of images read */

code = 0;
for ( k=0 ; feof(accumlist) == 0 ; k++ )
	{
	fscanf ( accumlist,"%s\n",filename );
	fdimg = open ( filename,O_RDONLY );
	fprintf ( stderr,"%s ",filename );
	code = read ( fdimg,img,ncol*nrow*2 );
	
	tot = 0.;
	for ( j=yfirst ; j<yfirst+64 ; j++ )
		{
		ip = img;
		ip += xfirst;
		ip += j*ncol;
		for (i=0; i<64 ; i++ )
			tot += *ip++;
		}
	tot = 10000.*(64.*64.)/tot;

	ip = img;
	ap = accum;
	for ( j=0 ; j<nrow ; j++ )
		for (i=0; i<ncol ; i++ )
			{
			ftemp = *ip;
			ftemp *= tot;
			*ap += ftemp;
			ip++;
			ap++;
			}
	fprintf ( stderr,"%7.2f \n",tot );
	}
numimg = (float)k;

ap = accum;
ip = img;
for ( j=0 ; j<nrow ; j++ )
	for (i=0; i<ncol ; i++ )
		{
		*ap = *ap/numimg;
		stemp = *ap + 0.5;
		*ip = stemp;
		ip++;
		ap++;
		}

write ( 1,img,record*nrow);

fclose ( accumlist );

exit ( 0 );

usage:
	fprintf (stderr, "accumulate filelist >accumulated_image\n" );
	exit (-1);

}

