/*
		rotchip angle < infile > outfile

		Rotate a chip image by amount angle
		Also fix up IDL up and down problem

		Translated from Alice's rotAimg.pro IDL program.
		DFE.

		arg is a floating point constant  or file
*/


#include		<stdio.h>
#include		<stdlib.h>
#include		<errno.h>
#include		<fcntl.h>
#include		<math.h>
#include		"dim.h"

main(argc,argv)
char		**argv;
int		argc;
{
FILE		*angfd;
char		*p;
int			read(),write();
int			lx,ly,nx,ny;
short		*img,*rnew;
float		ang,mysin,mycos,cx,cy,dx,dy,ox,oy;
float		fx,fy,fny,fnysin,fnycos,fnx,fox,foy;
float		rndr = 0.50005;
register	short	*ip,*rp;

int			nrow,ncol,record;

sscanf ( getenv ( "XDIM" ),"%d",&ncol );
sscanf ( getenv ( "YDIM" ),"%d",&nrow );
record = 2*ncol;
if ( ncol == 0 ) 
	{
	ncol = NCOL;
	nrow = NROW;
	record = RECORD;
	}
img = (short*)malloc ( (size_t)(2*ncol*nrow) );
rnew = (short*)malloc ( (size_t)(2*ncol*nrow) );
/*fprintf ( stderr,"%d %d\n",ncol,nrow );*/


if ( argc == 2 )
	{
	p = *++argv;
	if ( ( *p != '+' ) && ( *p != '-' ) )
		{
		if ( ( angfd = fopen ( p,"r" ) ) < (FILE*)0 )
			{
			fprintf ( stderr," open error %d %s\n",angfd,p);
			goto usage;
			}
		fscanf ( angfd,"%f",&ang );
		fclose ( angfd );
		}
	else 
		sscanf ( p,"%f",&ang );
	}
else
	goto usage;

dx = ncol;
dy = nrow;
cx = (ncol-1.)/2.;
cy = (nrow-1.)/2.;

read ( 0,img,ncol*nrow*2 );

ang = -ang * .01745;
mysin = (float)sin((double)ang);
mycos = (float)cos((double)ang);

for (ny=0; ny < nrow ; ny++)
	{
	fy = ny;
	fny = fy-cy;
	fnysin = fny*mysin-cx;
	fnycos = fny*mycos+cy;
	for ( nx=0 ; nx < ncol ; nx++ )
		{
		fx = nx;
		fnx = fx-cx;
		fox = fnx*mycos-fnysin;
		foy = fnycos+fnx*mysin;
		ox = fox + rndr;
		oy = foy + rndr;
		lx = ox;
		ly = oy;
		rp = rnew;
		rp += nx;
		rp += ncol*(nrow-1-ny);
		if ( (lx<0) || (lx >= ncol) || (ly<0) || (ly >= nrow) )
			{
			*rp = 0;
			}
		else
			{
			ip = img;
			ip += lx;
			ip += ncol*ly;
			*rp = *ip;
			}
		}
	}

write ( 1,rnew,record*nrow);

exit ( 0 );


usage:
fprintf ( stderr,"rotchip ang < infile > outfile ang is signed float\n");
fprintf ( stderr,"or file name\n" );

}

