;This procedure is intended for use as part of the CHIAS system.  This system
;has been developed by the HAO CHIP project to facilitate the initial
;quality assurance procedures required for new CHIP data.  Please make
;no changes to any of the files in this directory without first contacting
;CHIP personnel.
;
;   Questions regarding CHIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   This module loads the new color table when the user requests a change.
;   It's primary task is to set up the input for the tvlct procedure.
;
pro chias_colorscale, val
@chias_common

path =  '/home/cordyn/color_idl/'

case val of
   'B/W LIN'   : filename = path + 'bw0.rgb'
   'B/W EXP2'  : filename = path + 'bw2.rgb'
   'B/W EXP5'  : filename = path + 'bw5.rgb'
   'B/W LG-5'  : filename = path + 'bw-5.rgb'
   'B/W LG-20' : filename = path + 'bw-20.rgb'
   'RED'       : filename = path + 'chipcol.rgb'
endcase

get_lun, lun
openr, lun, filename

red = intarr(256)
green = intarr(256)
blue = intarr(256)

readu, lun, red
readu, lun, green
readu, lun, blue

close, lun
free_lun, lun

tvlct, red, green, blue

return
end
