;This procedure is intended for use as part of the CHIAS system.  This system
;has been developed by the HAO CHIP project to facilitate the initial
;quality assurance procedures required for new CHIP data.  Please make
;no changes to any of the files in this directory without first contacting
;CHIP personnel.
;
;   Questions regarding CHIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   The purpose of this module is to declare all the common blocks used by
;   the CHIAS system.  This module is called by any module that has anything
;   to do with plotting or processing data.  There are no procedure or end
;   statements as this module will be included in procedures via batch file
;   execution.
;

;Debugging block- to be removed for release version.
;common chias_debug, cmnt_in

;chip image size, and display sizes.
common chias_imagesz, pixx,pixy, scl, xsz,ysz, wxsz,wysz, wxp,wyp , cstrlen, $
		      im_array

;Widget identifications, base names listed first.
common chias_widget, base, col1b, col1c, col1d, col1e, col1eb, col1fb, $
	col2b, col2ba, $
	col2baa, col2bab, col2bac, col2bad, col2bae, col2baf, col2bag, $
	col2bb, usr_out1, obsdat, obstim,$
	solrad, nexpos, aptwhl, daysfil, filtwhl, occwhl, hotpix, coldpix,$
	usr_out2, usr_in1 , realexit

;Variables for plotting.
common chias_plot, plot_index1, pwin_inds, ii, n_imgs, time_slide,$
	slide_set, next_intyp, enlarge_win, enlarged, gridded, title, grids

;Variables for data access and manipulation.
common chias_data,  avail_day, dataday,           $
		    hsr_fnms, csr_fnms,           $
		    hsc_fnms, csc_fnms, hsh_fnms, bsh_fnms, $
		    hfr_fnms, cfr_fnms,           $
		    hbr_fnms, ssr_fnms, wsr_fnms, $
		    paint_fnms, $
		    fnms, datascale, hdrs, info_set, tmarr,$
		    std_hot,std_cold

;Variables for user info output.
common chias_userout, imtyp, totim, curim, hot_pix, cold_pix

;Variables for logfile entries.
common chias_logfiles,                        $
	maind,                                $
	cur_typ, cur_done, cur_qual, cur_summ,$
	log_done, cmnts_done, summs_done, $
	das_done, h_done, $ 
	arch_in, $
	nxlog,   $
	start_time, stop_time, op_name, wrongtyp, $
	sav_comm, $
	daily_summ, helium_events, $
	hsh_arch_fnm
common chias_cmnts,                        $
	    hsr_cmnts, csr_cmnts,            $
	    hsc_cmnts, csc_cmnts, hsh_cmnts, bsh_cmnts, $
	    hfr_cmnts, cfr_cmnts,            $
	    hbr_cmnts, ssr_cmnts, wsr_cmnts, $
	    paint_cmnts, $
	    hsr_done, csr_done,           $
	    hsc_done, csc_done, hsh_done, bsh_done, $
	    hfr_done, cfr_done,           $
	    hbr_done, ssr_done, wsr_done, $
	    paint_done, $
	    hsr_qual, csr_qual,           $
	    hsc_qual, csc_qual, hsh_qual, bsh_qual, $
	    hfr_qual, cfr_qual,           $
	    hbr_qual, ssr_qual, wsr_qual, $
	    paint_qual

;Variables for saving and recalling images.
common chias_save_recall, save1_typ, save2_typ, save3_typ, save1_win,$
	save2_win, save3_win, save1_info, save2_info, save3_info, saved,$
	save1_pix, save2_pix, save3_pix



