
;This procedure is intended for use as part of the CHIAS system.  This system
;has been developed by the HAO CHIP project to facilitate the initial
;quality assurance procedures required for new CHIP data.  Please make
;no changes to any of the files in this directory without first contacting
;CHIP personnel.
;
;   Questions regarding CHIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   This module is not used during normal CHIAS system operation.  Its 
;   purpose is to compile all of the other CHIAS modules and then save
;   them as a stored IDL session under the name 'chias_compiled.dat'.
;   Then starting the system simply requires restoring the saveset.  This
;   procedure should be executed batch style (by typing @chias_compile)
;   after any changes are made to the code of any module.
;
.run chias_setup.pro
.run chias_dayselect.pro
.run chias_filesort.pro
.run chias_widgets.pro
.run chias_load_images.pro
.run chias_parse_hdrs.pro
.run chias_imchange.pro
.run chias_colorscale.pro
.run chias_logenter.pro
.run chias_writelogs.pro
.run chias_logstatus.pro
.run chias_enlarge.pro
.run chias_save.pro
.run chias_recall.pro
.run chias_title.pro
.run chias_setgrid.pro

print, ' '
print, '   Saving routines...'
save, /routines, filename = 'chias_compiled.dat'

exit
