;This procedure is intended for use as part of the CHIAS system.  This system
;has been developed by the HAO CHIP project to facilitate the initial
;quality assurance procedures required for new CHIP data.  Please make
;no changes to any of the files in this directory without first contacting
;CHIP personnel.
;
;   Questions regarding CHIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   The purpose of this module is to display the full-size version for a
;   selected image.
;
pro chias_enlarge, task
@chias_common

enlarged = 1		;Flag to tell chias_imchange to erase large image.

if task eq 1 then begin		;Load image from file to enlarge.
   big_tmp = readimg (maind + dataday + '/' + fnms(ii), pixx,pixy)
   big_tmp = big_tmp(0:pixx-1, 0:pixy-1)
   big_im  = big_tmp
   window, /free, xsize = pixx, ysize = pixy , /pixmap
   enlarge_win = !d.window
   wset, enlarge_win

   case datascale of	;Write large image to pixmap according to scaling.
      0 : tv, bytscl(big_im, min=cold_pix(ii), max=hot_pix(ii))
      1 : tv, bytscl(big_im, min=std_cold    , max=std_hot    )
   endcase

   xs = pixx/2 - wxsz/2	   ;Center the image.
endif

if task eq 2 then xs = 0	        ;Move image left
if task eq 3 then xs = pixx/2 - wxsz/2	;Center the image.
if task eq 4 then xs = pixx   - wxsz    ;Move image right 

ys = pixy/2 - wysz/2

wset, plot_index1
device, copy = [xs, ys, wxsz , wysz , 0, 0, enlarge_win]

return
end
