;This procedure is intended for use as part of the CHIAS system.  This system
;has been developed by the HAO CHIP project to facilitate the initial
;quality assurance procedures required for new CHIP data.  Please make
;no changes to any of the files in this directory without first contacting
;CHIP personnel.
;
;   Questions regarding CHIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   This module oversees the arrangement of the log file entries to
;   form the final output to be written to the log files.
;
pro chias_logenter, cmnt_in
@chias_common

if cmnts_done ne 1 then begin	;First section for image comment input.

   if arch_in eq 1 then goto, ARCHIN

   case cur_typ of ;;;;{
      'hsr' : begin
		  hsr_cmnts(ii)=cmnt_in
		  hsr_done (ii)=1         &  cur_done=hsr_done
		  hsr_qual (ii)=cur_qual
	      end
      'csr' : begin
		  csr_cmnts(ii)=cmnt_in
		  csr_done (ii)=1         &  cur_done=csr_done
		  csr_qual (ii)=cur_qual
	      end
      'hsc' : begin
		  hsc_cmnts(ii)=cmnt_in
		  hsc_done (ii)=1         &  cur_done=hsc_done
		  hsc_qual (ii)=cur_qual
	      end
      'csc' : begin
		  csc_cmnts(ii)=cmnt_in
		  csc_done (ii)=1         &  cur_done=csc_done
		  csc_qual (ii)=cur_qual
	      end
      'hsh' : begin
		  hsh_cmnts(ii)=cmnt_in
		  hsh_done (ii)=1         &  cur_done=hsh_done
		  hsh_qual (ii)=cur_qual
	      end
      'bsh' : begin
		  bsh_cmnts(ii)=cmnt_in
		  bsh_done (ii)=1         &  cur_done=bsh_done
		  bsh_qual (ii)=cur_qual
	      end
      'hfr' : begin
		  hfr_cmnts(ii)=cmnt_in
		  hfr_done (ii)=1         &  cur_done=hfr_done
		  hfr_qual (ii)=cur_qual
	      end
      'cfr' : begin
		  cfr_cmnts(ii)=cmnt_in
		  cfr_done (ii)=1         &  cur_done=cfr_done
		  cfr_qual (ii)=cur_qual
	      end
      'hbr' : begin
		  hbr_cmnts(ii)=cmnt_in
		  hbr_done (ii)=1         &  cur_done=hbr_done
		  hbr_qual (ii)=cur_qual
	      end
      'ssr' : begin
		  ssr_cmnts(ii)=cmnt_in
		  ssr_done (ii)=1         &  cur_done=ssr_done
		  ssr_qual (ii)=cur_qual
	      end
      'wsr' : begin
		  wsr_cmnts(ii)=cmnt_in
		  wsr_done (ii)=1         &  cur_done=wsr_done
		  wsr_qual (ii)=cur_qual
	      end
      'paint' : begin
		  paint_cmnts(ii)=cmnt_in
		  paint_done (ii)=1         &  cur_done=paint_done
		  paint_qual (ii)=cur_qual
	      end
   endcase ;;;;}


   next_intyp = min(where(cur_done eq 0))	;Check to see if all cmnts
					        ;are in for the current 
						;image type.
   if next_intyp ne -1 then begin ;;;;{
      widget_control, nxlog, set_value = string(next_intyp)
      chias_imchange, 'NXLOG'
      widget_control, usr_out2, set_value = ' '
      widget_control, usr_in1, set_value = ''
   endif else begin
      widget_control, nxlog, set_value = ''
      if cur_typ ne 'hsh' then begin
	 widget_control, usr_out1, set_value = 'Done with this type.'
	 case cur_typ of
	    'hsr' : log_done(1) = 1
	    'csr' : log_done(2) = 1
	    'hsc' : log_done(3) = 1
	    'csc' : log_done(4) = 1
	    'hfr' : log_done(6) = 1
	    'cfr' : log_done(7) = 1
	    'hbr' : log_done(12) = 1
	    'ssr' : log_done(13) = 1
	    'wsr' : log_done(14) = 1
	    'paint' : log_done(15) = 1
	    'bsh'   : log_done(16) = 1
	 endcase
       endif else begin
	  widget_control, col2bab, sensitive = 1
	  widget_control, usr_out1, set_value = $
	  'Select archive image for '+cur_typ+' images.'
       endelse
   endelse  ;;;; }


   ARCHIN:   ;Jump to here if archive image is being selected.

   if arch_in eq 1 then begin
      widget_control, usr_out1, set_value =$
      'Got it.  Enter Summaries or select another image type and continue.'
      widget_control, usr_out2, set_value = 'ARCH'
      widget_control, col2bab, sensitive = 0
   endif
   arch_in = 0 				;Reset arch. select indicator.
   more = where(log_done eq 0)		;Check to see if cmnts are done
   if more(0) eq -1 then cmnts_done = 1	;for ALL image types.  If so, proceed
endif					;with summaries.

return
end
