;This procedure is intended for use as part of the CHIAS system.  This system
;has been developed by the HAO CHIP project to facilitate the initial
;quality assurance procedures required for new CHIP data.  Please make
;no changes to any of the files in this directory without first contacting
;CHIP personnel.
;
;   Questions regarding CHIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   This module creates a temporary widget to display the information to
;   the user regarding which images have log entries, which archive
;   images have been selected, etc.  This widget is destroyed upon exit.
;
pro chias_logstatus
@chias_common

base2 = widget_base(/column, title = 'LOGFILE STATUS')

dm = widget_label(base2, value = 'hsh IMAGES NEEDING LOG:')
if hsh_fnms(0) ne 'n' and (where(hsh_done ne 1))(0) ne -1 then begin
   tmp = indgen(n_elements(hsh_done))
   tmp = tmp(where(hsh_done ne 1))
   lgn = strtrim(tmp,2)
endif else lgn = 'NONE'
lg_stat = widget_text(base2, value = lgn)


if hsh_arch_fnm ne ' ' then begin
   hsh_ar_str = 'HAS BEEN SELECTED.'
endif else hsh_ar_str = 'NEEDS TO BE SELECTED.'

dm = widget_label(base2, value = ' ')
dm = widget_label(base2, value = 'HELIUM ARCHIVE IMAGE ' + hsh_ar_str)
dm = widget_label(base2, value = ' ')

if das_done eq 1 then das_str = 'COMPLETE' else das_str = 'INCOMPLETE'
if h_done   eq 1 then h_str = 'COMPLETE' else h_str = 'INCOMPLETE'

dm = widget_label(base2, value = 'DAILY SUMMARY IS ' + das_str)
dm = widget_label(base2, value = 'EVENT SUMMARY IS ' + h_str)

bail = widget_button(base2, value = 'DONE')

widget_control, /realize, base2

ev = widget_event(base2)
widget_control, base2, /destroy

return
end
