;This procedure is intended for use as part of the CHIAS system.  This system
;has been developed by the HAO CHIP project to facilitate the initial
;quality assurance procedures required for new CHIP data.  Please make
;no changes to any of the files in this directory without first contacting
;CHIP personnel.
;
;   Questions regarding CHIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   The purpose of this module is to take the large string array called
;   hdrs, and pull out of it the information desired for display in
;   the information section to the right of the screen.  The array
;   hdrs is generated by chias_load_images, which simply throws all
;   the FITS header information into hdrs as it is reading out the
;   image data from file.
;   Since at present there is no fits header, I'm fudging things mightly!
;   --Alice
;
pro chias_parse_hdrs
@chias_common

info_set = strarr(n_imgs, 8)

for t = 0, n_imgs - 1 do begin
   info_set(t,0) = strtrim(strmid(fnms(t), 0, 6), 2)          ; obsdat
   info_set(t,1) = strtrim(strmid(fnms(t), 7, 6), 2)          ; obstim
   info_set(t,2) = '1'                                        ; nexpos
endfor
return
end
