pro chias_setgrid
@chias_common

nray=720        &                      nraym1=nray-1
grid_disk_color =1
grid_space_color=1



;;; Assume xcen, ycen and pix2r are constant for all days in CHIP data. 
xcen  = xsz/2  & ycen = ysz/2 & pix2r = 138.0      


acirc = !PI * 2.0 / float(nray)
dp    = findgen(nray) * acirc  +  acirc * (0.25 * (float(nray)))
dpx   = intarr(nray)
dpy   = intarr(nray)
rnder = 0.5005
radius= 1.00
dpx   = fix ( cos(dp) * pix2r * radius + xcen + rnder )  ; For disk size
dpy   = fix ( sin(dp) * pix2r * radius + ycen + rnder )  ; For disk size


grd          = bytarr(xsz,ysz)	;for grid image
grd(*,*)     = 0
grd(dpx,dpy) = grid_disk_color


d2r   = !pi/180.
for Theta=10.,90.,10. do begin ;{               Grids of longitude on the disk.
    th = Theta*d2r
    dpx   = fix ( cos(dp)*cos(th) * pix2r * radius + xcen + rnder )
    grd(dpx,dpy)=grid_disk_color
endfor ;}

for Theta=0.,180.,10. do begin ;{               Grids of latitide on the disk.
    th = Theta*d2r
    dpx   = fix ( cos(dp)*sin(th) * pix2r * radius + xcen + rnder )
    dpy(*)= fix ( cos(th)         * pix2r * radius + ycen + rnder )
    grd(dpx,dpy)=grid_disk_color
endfor ;}

for radius=1.,1.5,0.10 do begin ;{              Grids of radial height.
    dpx   = fix ( cos(dp) * pix2r * radius + xcen + rnder ) 
    dpy   = fix ( sin(dp) * pix2r * radius + ycen + rnder )
    bp = where (dpx le 0 ) 
    if (bp(0) ne -1) then begin ;{
        dpx(bp)=0  &  dpy(bp)=0
    endif;}
    bp = where (dpy le 0 ) 
    if (bp(0) ne -1) then begin ;{
        dpx(bp)=0  &  dpy(bp)=0
    endif ;}
    grd(dpx,dpy)=grid_space_color
endfor ;}

apltrad = (findgen(pix2r/2) + pix2r) / pix2r
for Theta=0.,360.,10. do begin ;{                       Grids of Position Angle.
    th = Theta*d2r
    dpx = fix ( cos(th) * pix2r * apltrad + xcen + rnder )
    dpy = fix ( sin(th) * pix2r * apltrad + ycen + rnder )
    bp = where (dpx le 0 ) 
    if (bp(0) ne -1) then begin;{
        dpx(bp)=0  &  dpy(bp)=0
    endif;}
    bp = where (dpy le 0 ) 
    if (bp(0) ne -1) then begin ;{
        dpx(bp)=0  &  dpy(bp)=0
    endif;}
    grd(dpx,dpy)=grid_space_color
endfor ;}



im_tmp   = readimg(maind + dataday + '/' + fnms(ii), pixx, pixy)

;im_array = rebin(im_tmp(0:xsz*scl-1,0:ysz*scl-1),xsz,ysz)
im_array = im_tmp(0:xsz*scl-1,0:ysz*scl-1)

case datascale of
      0 :  im_array =  bytscl(im_array, min=cold_pix(ii), max=hot_pix(ii))
      1 :  im_array =  bytscl(im_array, min=std_cold    , max=std_hot   )
endcase

grd(where(grd eq 0)) = im_array(where(grd eq 0))   ;  combine image with grid

tv, grd, wxp, wyp                                  ;  display it

end
