;This procedure is intended for use as part of the CHIAS system.  This system
;has been developed by the HAO CHIP project to facilitate the initial
;quality assurance procedures required for new CHIP data.  Please make
;no changes to any of the files in this directory without first contacting
;CHIP personnel.
;
;   Questions regarding CHIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   The purpose of this module is to call the module which initializes the
;   common blocks used by the system and initialize some system parameters.
;   This procedure is called only once by chias_startup when the system
;   is first activated.
;
pro chias_setup
@chias_common

SET_PLOT,'X'
DEVICE,pseudo_color=8


maind = '/puu/f/cordyn/CHIP/'
maind = '/orwell/e/cordyn/chippro/'
maind = '/puka/f/cordyn/chippro/'


realexit=0
cur_qual = 'none'		;Initialize all logfile parameters.
log_done = intarr(17)
cmnts_done = 0
summs_done = 0
cur_summ = ' '
arch_in = 0
hsh_arch_fnm = ' '
das_done = 0
h_done = 0
wrongtyp = 0

pwin_inds = [0]			;Initialize plotting variables.
enlarged = 0
title = 1
!x.style = 4
!y.style = 4

saved = [0, 0, 0]		;Initialize save slot indicators.

; Because of the new puka upgrade, I want to try to see if I can
;	view a whole day of CHIP without rebinning, --Tony
;pixx=1534 & pixy=1030  & scl=3 & xsz=pixx/scl & ysz=pixy/scl
pixx=1534 & pixy=1030  & scl=1 & xsz=pixx/scl & ysz=pixy/scl

wxsz =1024  & wysz=1030
wxsz =800   & wysz=800
wxsz =800   & wysz=600   ;;;;; For testing on slug...........
wxsz =800   & wysz=900
wxsz =1100   & wysz=900   ;;;;; For running on new puka

wxp= (wxsz-xsz)/2 & wyp=(wysz-ysz)/2

cstrlen = 720 ; Length of a string that can be entered for comm_in

;Set up three windows to be used for the save and recall functions later.
window, /free, xsize = pixx , ysize =  pixy , /pixmap, colors=256
save1_win = !d.window
window, /free, xsize = pixx , ysize =  pixy , /pixmap, colors=256
save2_win = !d.window
window, /free, xsize = pixx , ysize =  pixy , /pixmap, colors=256
save3_win = !d.window

return
end
