;This procedure is intended for use as part of the CHIAS system.  This system
;has been developed by the HAO CHIP project to facilitate the initial
;quality assurance procedures required for new CHIP data.  Please make
;no changes to any of the files in this directory without first contacting
;CHIP personnel.
;
;   Questions regarding PIAS should be directed to:
;
;			Ray Wrigley     FL2 3084  x1588
;			Alice Lecinski  FL2 3037  x1523
;
;   This is chias_startup.pro.  This procedure controls the entry and exit
;   from the CHIAS system after IDL has been started by the chias script.
;
print, ' '
print, ' '
print, ' '
print, '   Restoring compiled procedures...'
restore, 'chias_compiled.dat'

chias_setup			;Call to procedure to initialize various
				;processing parameters.
@chias_common			;Declare all common blocks.
!quiet = 1

daily_summ = ' '
helium_events = ' '

;Get operator name, for use in writing the log file later.
print, ' '
print, ' '
op_name = ' '
read, '   Enter operator name ==> ', op_name
print, ' '

;Create string array of data directory names from default data directory.
mystr = '(cd '+ maind + '; ls -1)'
spawn, mystr, direc_list
direc_str1 = direc_list(where(strmid(direc_list, 0, 1) eq '0') )

avail_day = strmid(direc_str1, 0, 6)

chias_dayselect

chias_filesort

print, ' '
print, '   Creating widgets...'
chias_wgt_create		;Call to widget creation routine.  Control
				;is then handed to widget manager.
exit				;Leave IDL entirely when user is finished.
