/*
        MkFlat     (fimg)
        
*/

#include        <stdio.h>
#include        "dim.h"

#define NUMSLOPE   (601)
#define SWATH       (50)

int
MkFlat     (img,ref,air_factor)     float *img, *ref  ; 
				    float  air_factor ;
{
    int   doprint       = 1;
    int   do_LstSquares = 1;
    int   ii,jj;
    int   npts=NUMSLOPE, swath=SWATH;
    float xcen,ycen;
    float xx[NUMSLOPE],yy[NUMSLOPE], *pxx, *pyy, *pxs, *pys;
    float xs[NUMSLOPE],ys[NUMSLOPE];
    float Ax,Bx,Rx;
    float Ay,By,Ry;
    float xfac,yfac,ftmp;
    long xstrt,ystrt;
    register float   *ip, *ir;


    Bx = air_factor;
    By = 0.        ;

    xcen = (ncol-1)*0.5;
    ycen = (nrow-1)*0.5;

    if ( do_LstSquares == 1 ) {

	pxx=xx; pxs=xs;
	for (ii=0;ii<npts;ii++){
	    *pxx = (float)ii;
	    xstrt = (long)(xcen-(npts -1)*0.5 + ii);
	    ystrt = (long)(ycen-(swath-1)*0.5     );
	    ip = img + (long)(xstrt + ncol*ystrt);
	    *pxs = -9999.;
	    for(jj=0;jj<swath;jj++){
		ftmp = *(ip + jj*ncol);
		*pxs = ( *pxs > ftmp )  ? *pxs : ftmp;
	    }
	    pxs++; pxx++;
	}

	pyy=yy; pys=ys; 
	for (ii=0;ii<npts;ii++){
	    *pyy = (float)ii;
	    xstrt = (long)(xcen-(swath-1)*0.5     );
	    ystrt = (long)(ycen-(npts -1)*0.5 + ii);
	    ip = img + (long)(xstrt + ncol*ystrt);
	    *pys = -9999.;
	    for(jj=0;jj<swath;jj++){
		ftmp = *(ip + jj);
		*pys = ( *pys > ftmp )  ? *pys : ftmp;
	    }
	    pys++; pyy++;
	}


	do_lst(&Ax,&Bx,&Rx,xx,xs,npts,0);
	do_lst(&Ay,&By,&Ry,yy,ys,npts,0);

	if(doprint) {
	    /*
	    for(ii=0;ii<npts;ii++)fprintf(stderr,"%d %f %f\n",ii,xs[ii],ys[ii]);
	    */
	    fprintf(stderr,"\tAx , Bx: %7.4f %7.4g RR %5.2f\n",Ax,Bx,Rx);
	    fprintf(stderr,"\tAy , By: %7.4f %7.4g RR %5.2f\n",Ay,By,Ry);
	}
	Bx = ( Rx > 0.85 )  ? Bx : air_factor ;
	By = ( Ry > 0.85 )  ? By : 0.0 ;
    }


    ip=img; ir=ref;
    for(ii=0;ii<imsz;ii++){
	if( *ir > 0. ) {
	    xfac = Bx * ( xcen - ii%ncol ) ;
	    yfac = By * ( ycen - ii/ncol ) ;

	    *ip += xfac + yfac;
	}
	ir++; ip++;
    }


}
