/********************** doshift ***********************/

/*   Code to "center" any "disk" type image.  This code applies the x and y
     shifts found by routine "findshift()". */

/*   Pass this code --> img     -- your short image.
                       fimg     -- a spot in memory to accumulate your
                                   recentered image. same size as your "img"
                                   above, but a float.
                       numx        the x-dimension of your "img"
                       numy        the y-dimension of your "img"
                       xshi        the x shift in fractional pixels 
                                       found by findshift()
                       yshi        the y shift in fractional pixels 
                                       found by findshift()
*/

#include <stdio.h>

void doshift(img,fimg,numx,numy,xshi,yshi)
    short *img;
    float *fimg , xshi,yshi;
    int numx,numy;
{

    long ii,jj,kk,strt;
    long imsz;
    register float *ff, *tt;
    float xx,xxm1,yy,yym1;
    float *timg;
    register float *t1,*t2,*t3,*t4;
    register float *qq, *pp, *ss;
    register short *iq;
    int shift, off;
    float xshift,yshift;

    /* Copy the short image to a float image. */
    imsz=numx*numy;      timg = (float *) malloc ( imsz*sizeof ( float )) ;

    tt= timg; iq=img; for(ii=0;ii<imsz;ii++) *tt++ = *iq++;


    /* Get the fractional and integer portions of the x and y shift. */
    xshift = xshi ;
    yshift = yshi ;
    if(xshift < 0.0) {
        xx = 1. + (xshift - (int)xshift); xxm1=1.-xx;
        xshift -= 1.0;
    }
    else {
        xx = xshift-(int)xshift; xxm1=1.-xx;
    }
    if(yshift < 0.0) {
        yy = 1. + (yshift - (int)yshift); yym1=1.-yy;
        yshift -= 1.0;
    }
    else {
        yy = yshift-(int)yshift; yym1=1.-yy;
    }
    shift = (int)yshift*numx+(int)xshift;  /* This is how much to shift
                                              the entire array in whole
                                              integer dimensions, looking
                                              at the array as if it was 1-d. */

    /*   Position to the integer portion of the shift. */
    if(shift>=0) { off=shift;        ff=fimg+off; tt=timg;     }
    else         { off = shift * -1; ff=fimg;     tt=timg+off; }


    tt += numx; ff += numx;
    t1=tt-1;
    t2=tt;
    t3=tt-1-numx;
    t4=tt  -numx;

    strt = imsz-off-numx;                  /* Apply the fractional portion */
    for(ii=0;ii<strt;ii++)                 /* of the shift. */
        *ff++ +=  *t1++ * xx  *yym1 + 
                  *t2++ * xxm1*yym1 + 
                  *t3++ * xx  *yy   + 
                  *t4++ * xxm1*yy           ;

    free( (char *) timg );
}
