/**************** find_shift ***********************/
/*
    Sets up a padded array area for findshift to use to find the center
    and diameter.

    Need to pad the top and bottom of the array since the disk is
    shifted around the f.o.v. to find the flat field.

    If padding is not needed, find_shift need not be called before
    findshift.

/******************************************************************************/

#include <stdio.h>

void find_shft(img,numx,numy,xshi,yshi,diam,    pad,xtra)
    short *img,*pad;
    float *xshi,*yshi, *diam;
    int numx,numy;
    int xtra;
{

    int ii,jj;
    register short *op, *ip;

    for(jj=0;jj<xtra;jj++) {
        ip = img ;
        op = pad + jj*numx;
        for(ii=0;ii<numx;ii++)   *op++ = *ip++;
    }
    for(jj=numy;jj<numy+xtra;jj++) {
        ip = img + (numy-1)*numx;
        op = pad +        jj*numx;
        for(ii=0;ii<numx;ii++)   *op++ = *ip++;
    }

    numy=numy+2*xtra;
    fprintf(stderr,"%.1f %.1f %.1f",*xshi,*yshi,*diam);
    findshift(pad,      numx,numy,xshi,yshi,diam);

    fprintf(stderr,"%.1f %.1f %.1f",*xshi,*yshi,*diam);

}
