/*
                readimg  (filenm,img)
                writeimg (filenm,img)

                Reads  an array "img" from the file "filenm"
		or
                Writes an array "img"  to  the file "filenm"

		"img" is assumed to be a short array of size "imsz"
*/


#include                <stdio.h>
#include                "dim.h"

int
printit(astring) char *astring;
{
    fprintf(stderr,"\t%s\t",astring);
}
int
readimg(filenm,img) char *filenm; short *img; 
{
    int  ii,doprint=0;
    FILE *fid;

    if(doprint) fprintf(stderr,"\t\tReading %s\n",filenm);
    if ( ( fid = fopen(filenm,"r") ) < (FILE*)0 ) {
	fprintf(stderr,"Error openning %s for reading. Error %d\n",filenm,ii);
	exit(-90);
    }
    if( ( ii = fread (img,sizeof(short),imsz,fid)) != imsz ) {
	fprintf(stderr,"Only read %d shorts from %s\nExpected %d",
		        ii,filenm,imsz);
	exit(-92);
    }
    fclose(fid);
}

int
writeimg(filenm,img) char *filenm; short *img; 
{
    int  ii,doprint=0;
    FILE *fid;

    if(doprint) fprintf(stderr,"\t\tWriting %s\n",filenm);
    if ( ( fid = fopen(filenm,"w") ) < (FILE*)0 ) {
	fprintf(stderr,"Error openning %s for writing. Error %d\n",filenm,ii);
	exit(-90);
    }
    if( ( ii = fwrite (img,sizeof(short),imsz,fid)) != imsz ) {
	fprintf(stderr,"Only wrote %d shorts from %s\nExpected %d",
			ii,filenm,imsz);
	exit(-92);
    }
    fclose(fid);
}

void
writefvalue(filenm,value)
    char *filenm;
    float value;
{
    int  ii,doprint=1;
    char *w;
    FILE *fid;

    if(doprint) fprintf(stderr,"\t\tWriting %s\n",filenm);
    if ( ( fid = fopen(filenm,"w") ) < (FILE*)0 ) {
	fprintf(stderr,"Error openning %s for writing. Error %d\n",filenm,ii);
	exit(-90);
    }

	fprintf(fid,"%10.2f\n",value);
    fclose(fid);
}



#include "shift.h"
void
writeshft_diam(filenm,list,shft,num,len)
    char *filenm, *list;
    SHFT shft;
    int  num,len;
{
    int  ii,doprint=0;
    char *w;
    FILE *fid;

    if(doprint) fprintf(stderr,"\t\tWriting %s\n",filenm);
    if ( ( fid = fopen(filenm,"w") ) < (FILE*)0 ) {
	fprintf(stderr,"Error openning %s for writing. Error %d\n",filenm,ii);
	exit(-90);
    }

    w=list;
    for(ii=0;ii<num;ii++){
	fprintf(fid,"%s: %10.2f %10.2f %10.2f\n",w,shft->X,shft->Y,shft->Dia);
	w+=len;
	shft++;
    }
    fclose(fid);
}
