#define NANNULI         (10)
#define NANN_PIXELS ( 60000)
#define RANGE       (  8193)

/*
#define INFL2    (0.02)     Inflection point of the 1st derritive of the
                            population distribution of the innermost annuli of
                            a CONTINUUM image. (zero slope of 2nd derrivative)
#define INFL2    (0.01)     Inflection point of the 1st derritive of the
                            population distribution of the innermost annuli of
                            a HELIUM    image. (zero slope of 2nd derrivative)
#define INFL2    (0.08)     Inflection point of the 
                            population distribution of the innermost annuli of
                            a CONTINUUM image. (zero slope of 1st derrivative)
#define INFL2    (0.098)    Inflection point of the 
                            population distribution of the innermost annuli of
                            a HELIUM    image. (zero slope of 1st derrivative)
*/
#define INFL2    (0.08)  /* Use CONTINUUM, inflection pt of 1st derrivative. */

#define MEAN     (0.50)  /* Really this is the median. */


/*  Rinner, Router and Rmean are all based on the continuum image.
    They are the positions of the annuli: 
	inner, outer and mean radii.

    AinfoH and AinfoC are the representative intensities for
    the annuli.  
    The helium (AinfoH) intensities:
	are measured from the brightest pixels -- where there
	is no excess absorbtion.
	The intensity is taken where the population of the
	helium intensities reach INFL2 (starting from the top,
	or brightest intensities).  INFL2 comes from where,
	in typical continuum images, the inflection point
	of the population curve occurs.  (The continuum is used
	because it has a "more normal" population distribution.)
    The continuum (AinfoC) intensities:
	just use the meadian of intensities in the annuli.
*/


#ifdef START
    double Rinner[NANNULI], Router[NANNULI], Rmean[NANNULI];
    double AinfoH[NANNULI], AinfoC[NANNULI];
    int  Na_pix[NANNULI];
    int (*a_idx)[NANN_PIXELS];
    int  a_indicies[NANNULI][NANN_PIXELS];
    short a_img[NANN_PIXELS];
    int  HIST[RANGE];
#else
    extern double Rinner[NANNULI], Router[NANNULI], Rmean[NANNULI];
    extern double AinfoH[NANNULI], AinfoC[NANNULI];
    extern int  Na_pix[NANNULI];
    extern int  (*a_idx)[NANN_PIXELS];
    extern int  a_indicies[NANNULI][NANN_PIXELS];
    extern short a_img[NANN_PIXELS];
    extern int  HIST[RANGE];
#endif
