#include                <stdio.h>
#include                <stdlib.h>
#include                <math.h>
#include                <errno.h>
#include                <fcntl.h>

#define START
#include                "dim.h"
#include                "shift.h"

#include                "acos.h"
#include                "acos_header.h"

#include                "params.h"

#define SLN      120        /* string length of filenames. */


short  img[IMSZ];
short  dimg[IMSZ];

char  (*ff)[SLN],  files[300][SLN];

struct acos_header acos_h, *ah;


main(an,av) int an; char *av[];
{
    int   ii,jj,kk;
    int   numimgs=0,alreadynorm8=0,sunpixadj=0;
    char  *w, *ww;
    short *ip;
    short inval=1,outval=0;
    double normal,avg,numpts, sunrad , sunpix ;
    double pi = 3.14159265358979;
    float  avg_radius=0. ;

    FILE  *fid;

    nrow = NROW;
    ncol = NCOL;
    imsz = IMSZ;
    im_nbytes=sizeof(short)*imsz;

    ah = &acos_h;
    ff=files;

    if ( an <= 1 ) { prsum() ; exit(3) ; }
 
    while (--an) { /* Read in any arguments, and the image filenames. */
        w = *++av ;
        if (*w == '?') { prsum(); exit(2); }
        if (*w == '-') { /* Check for flag arguments. */
            switch (w[1]) {
		case 'a':   alreadynorm8=1;
			    /*
			    fprintf(stderr,
			    "Data assumed already be norm\'ed to 8 images.\n");
			    */
			    break;
		case 's':   sunpixadj=1;
			    fprintf(stderr,
			    "Avg will be adjusted for number of sun pixels.\n");
			    break;
		default :
                            fprintf (stderr," unknown flag %s\n",*av);
                            prsum(); exit(1);
            }
	}
	else {
	    sprintf(*ff++,"%s",w);
	    numimgs++ ;
	}
    }

    ff=files;
    ah = &acos_h;
    for(ii=0;ii<numimgs;ii++) { readhdr(ff,ah);
	                        avg_radius += ah->Radius ;  /* In arcsec */ }

    sunrad = (double) avg_radius / ( (double) numimgs * 2.29 ) ; 
						     /* 2.29 pixels/arcsec */
    sunpix = ( pi*sunrad*sunrad ) ;

    if(sunpixadj==1) s_mkfakedisk(dimg,ah->Xdim,ah->Ydim,sunrad,inval,outval);


    ff=files;
    ah = &acos_h;
    for(ii=0;ii<numimgs;ii++) {
	readimg(*ff,img); rereadhdr(img,ah); z9hdr(img); zero_shifts(img, ah);

	if(sunpixadj==1) {
	    /* Adjust the average by the sun's area in pixels. */
	    stimes(img,dimg);

	    numpts = avg = 0. ;
	    ip = img;
	    for(jj=0;jj<imsz;jj++){
		if( *ip != 0 ) { numpts++; avg += (double)*ip; }
		ip++;
	    }
	    avg /= numpts; 

	    /* sunpix != numpts  ---->  WANT TO USE numpts 
	    normal = numpts / sunpix ;
	    fprintf(stderr,"numpts %.1lf sunpix %.1lf\n",numpts,sunpix);
	    avg *= normal;
	    */
	}
	else {
	    numpts = avg = 0. ;
	    ip = img;
	    for(jj=0;jj<imsz;jj++){
		if( *ip != -9999 ) { numpts++; avg += (double)*ip; }
		ip++;
	    }
	    avg /= numpts; 
	}


	if(alreadynorm8==0) {
	    /* Normalize the avg to a sum of 8 images. */
	    normal = 8./((double)(ah->Nsum));
	    avg *= normal;
	}

	fprintf(stdout,"%.2lf\n",avg);

	ff++;
    }

}

int
prsum() {
    static char help[] = "\
chip_avg [-an8] [-spa] [file1] [file2] ... [fileN]\n\
\n\
Example: chip_avg 96d043.210248.hsr \n\
\n\
Example: chip_avg 96d043.210249.csr \n\
\n\
This code averages a helium or continuum chip image excluding \n\
     the header, and shift areas,  and normalizes to a sum of 8 images.\n\
\n\
Flags       Description\n\
-----       -----------\n\
-an8        Indicates that the image has already been normalized \n\
	    to 8 exposures.\n\
\n\
-spa        The average will be corrected for the pixel area of the sun.\n\
\n\
";

    fputs (help,stderr);

}
