/*
		*****From David Elmore*****
                Fix the bias sag in the vertical direction
                in images taken with Megaplus.
 
                A reference value is computed from first
                100 columns starting at second and subtracted
                from all pixels in the row.
                First row is skipped as header may be there
                Next four rows are skipped as they contain junk.
*/

#include                <stdio.h>
#include                "dim.h"
#include "acos.h"
#include "acos_header.h"

int
ffixbias(img,a) float *img; struct acos_header *a;
{
    int  ii,jj,spot;
    register float *ip;
    float tot, stot;
    int mnYshift, mxYshift;
    int mnXshift, mxXshift;

    mnYshift =  500; mxYshift = -500;
    mnXshift =  500; mxXshift = -500;
    for(ii=0;ii<16;ii++){
        spot = (int) (a->Yshift[ii]);
        mnYshift = ( spot < mnYshift ) ? spot : mnYshift ;
        mxYshift = ( spot > mxYshift ) ? spot : mxYshift ;
        spot = (int) (a->Xshift[ii]);
        mnXshift = ( spot < mnXshift ) ? spot : mnXshift ;
        mxXshift = ( spot > mxXshift ) ? spot : mxXshift ;
    }

    
    /* Always skip at least the first collumn and row. */
    mxXshift = (mxXshift<1) ? 1 : mxXshift ;
    mxYshift = (mxYshift<1) ? 1 : mxYshift ;
    mnYshift = (mnYshift>0) ? 0 : mnYshift ;  /* Only want negative ones. */

    if(mxXshift>25) {
	fprintf(stderr,
	"Huge xshift found, %d, expect bad results from fixbias.\n",mxXshift);
	mxXshift=25;
    }

    for(jj=mxYshift;jj<nrow+mnYshift;jj++) {
	ip = img + ncol*jj;
        ip += mxXshift;             /* Skip past the biggest shift */
        tot = 0.;
        for(ii=1;ii<=100;ii++) tot += 1. * *ip++;
        tot = tot*0.01;
        stot = tot;

	ip = img + ncol*jj;
        *ip++ = 0;                        /* Zero the first collumn. */
        for(ii=1;ii<ncol;ii++){
	    *ip = *ip - stot;
	    *ip++;
	}
    }
}
