#include <stdio.h>
#include <ctype.h>

#define START
#include "dim.h"
#include "params.h"
#include "acos.h"
#include "acos_header.h"

char usage[] = "\
Changes the header of a chip file...\n\
and moves the file to an appropriate filename.\n\
\n\
fixheader [-b] [-r] [-h] [-c] file \n";

short  img[IMSZ];
struct acos_header acos , *ah;

char mvit[200];
char lsit[200];
char line[200];

main (an, av) char *av[]; {
    int doy;
    int ii,jj;
    int nfile=0;
    int wavey,timeH,timeM,timeS;
    char *p , filenm[200] , Filenm[200];
    FILE *ifid, *pfid, *ofid;
    char *fgetl() ;
    int oldwave, newwave;
    int  newHour, newMinute, newSec;

    wavey=0;
    timeH=timeM=timeS=0;

    if ( an <= 1 ) { prsum() ; exit(-5) ;
    }

    ah = &acos;

    while (--an) {
	if (*(p = *++av) == '-')		/* flag arguments */
	    switch (p[1]) {
	    case 'b':  newwave = WAVELENGTH_b ; wavey=1 ;
		       break;
	    case 'c':  newwave = WAVELENGTH_c ; wavey=1 ;
		       break;
	    case 'h':  newwave = WAVELENGTH_h ; wavey=1 ;
		       break;
	    case 'r':  newwave = WAVELENGTH_r ; wavey=1 ;
		       break;
	    case 'H':  --an; p = *++av;  sscanf(p,"%d",&newHour);   timeH=1 ;
		       break;
	    case 'M':  --an; p = *++av;  sscanf(p,"%d",&newMinute); timeM=1 ;
		       break;
	    case 'S':  --an; p = *++av;  sscanf(p,"%d",&newSec);    timeS=1 ;
		       break;
	    default:   fprintf (stderr," unknown flag %s\n",*av);
		       prsum(); exit(1);
	}
	else {
	    if (*p == '?') { prsum(); exit(2); }
	    if ((ifid = fopen (p, "r")) == NULL) {
		fprintf (stderr,"Could not open file %s\n",p);
		continue;
	    }
	    if ((jj = fread (img, 1, sizeof(img), ifid)) > 0) {
		fclose(ifid);
		rereadhdr(img,ah);
	

		NameChip(filenm,ah);
		fprintf(stderr,"Old name was %s     ",filenm);

		if ( wavey == 1 ) ah->Type   = ah->Type % 100 + newwave * 100;
		if ( timeH == 1 ) ah->Hour   = newHour;
		if ( timeM == 1 ) ah->Minute = newMinute;
		if ( timeS == 1 ) ah->Sec    = newSec;

		NameChip(filenm,ah);

		replacehdr(img,ah);
		if ( ( ofid = fopen(p,"w") ) < (FILE*)0 ) {
		    fprintf(stderr,"Error openning %s \n",p);
		    exit(-90);
		}
		if( ( ii = fwrite (img,1,sizeof(img),ofid)) <= 0 ) {
		    fprintf(stderr,"Only wrote %d shorts from %s\nExpected %d",
		    ii,p,IMSZ);
		    exit(-92);
		}
		fclose(ofid);
	
		sprintf(line,"");
		sprintf(lsit,"ls %s\n",filenm);         pfid=popen(lsit,"r+");
		fgetl  (line,sizeof(line),pfid);        ii=pclose(pfid);
	
		if( strlen(line) <= 1) {   /* filenm does not already exist. */
		    sprintf(mvit,"mv %s %s\n",p,filenm);
		    pfid=popen(mvit,"r+"); ii=pclose(pfid);
		}
		else {
		    fprintf(stderr,
			"\tFile  %s  had the same filename as: \t %s \n",
			p,filenm);
		}
	
	
	    }
	    else {
		fprintf(stderr,"\t\tError reading header...\n\n");
		continue;
	    }
	}
    }
}

prsum () {
   fprintf (stderr,usage);
}


/* From /hao/src/lib/misc/fgetl.c     */

char *eos;
 
char *
fgetl (s, n, iop) char *s; register int n; register FILE *iop; {
	register int c;
	char *cs = s;

	if ((iop->_flag & (_IONBF | _IOLBF)) == (_IONBF | _IOLBF)) {
	    c = read (fileno (iop), cs, --n);
	    if (c <= 0) iop->_flag |= (c-- < 0 ? _IOERR : _IOEOF);
	    else {
		cs += c;
		if (*(cs-1) == '\n') *--cs = '\0'; } }
	else if (feof (iop)) c = -1;
	else
	    while (--n > 0 && (c = getc (iop)) >= 0) {
		if (c == '\n') break;
		*cs++ = c; }
	eos = cs;
	if (c < 0 && cs == s) return (NULL);
	*cs = '\0';
	return (s);
}
