/*
 *	image.h
 *
 *	Items needed for image memory
 *
 *	David Elmore
 *
 *	Wed Jan  5 18:35:59 GMT 1994
 */

#define		CCD_COL		1534
#define		CCD_ROW		1032
#define		CCD_BUF		4
#define		CCD_BUF_SIZE	0x1000*( (2*CCD_COL*CCD_ROW)/0x1000 + 1 )

#define		NUM_COL		1534
#define		NUM_ROW		1030

#define		DPMON_COL	NUM_COL
#define		DPMON_ROW	NUM_ROW

#define		LOWK_COL	NUM_COL/2
#define		LOWK_ROW	NUM_ROW

#define		CHIP_COL	NUM_COL
#define		CHIP_ROW	NUM_ROW

/***** Number of records and their size found on the tape ****/

#define		NUM_REC			206
#define		REC_SIZE		15340

#define		DPMON_NUM_REC	NUM_REC
#define		DPMON_REC_SIZE	REC_SIZE

#define		LOWK_NUM_REC	NUM_REC
#define		LOWK_REC_SIZE	REC_SIZE

#define		CHIP_NUM_REC	NUM_REC
#define		CHIP_REC_SIZE	REC_SIZE

#define		DPMON_STATES	1		/* Single image */
#define		LOWK_STATES		4		/* Four modulation states */
#define		CHIP_STATES		3		/* Continuum, Major, Minor components */

#ifdef IMAGE
int		num_col[3] = {DPMON_COL,LOWK_COL,CHIP_COL};
int		num_row[3] = {DPMON_ROW,LOWK_ROW,CHIP_ROW};
int		first_col[3] = {(NUM_COL-DPMON_COL)/2,(NUM_COL-LOWK_COL)/2,(NUM_COL-CHIP_COL)/2};
int		first_row[3] = {(NUM_ROW-DPMON_ROW)/2,(NUM_ROW-LOWK_ROW)/2,(NUM_ROW-CHIP_COL)/2};
int		num_rec[3] = {DPMON_NUM_REC,LOWK_NUM_REC,CHIP_NUM_REC};
int		rec_size[3] = {DPMON_REC_SIZE,LOWK_REC_SIZE,CHIP_REC_SIZE};
int		num_state[3] = {DPMON_STATES,LOWK_STATES,CHIP_STATES};
char		*dark_name[3] = {"/local/d/Data/dpmon_dark",
				"/local/d/Data/lowk_dark",
				"/local/d/Data/chip_dark"};
char		*gain_name[3] = {"/local/d/Data/dpmon_gain",
				"/local/d/Data/lowk_gain",
				"/local/d/Data/chip_gain"};
char		*limb_name[3] = {"/local/d/Data/dpmon_limb",
				"/local/d/Data/lowk_limb",
				"/local/d/Data/chip_limb"};
#else
extern	int	num_col[3];
extern	int	num_row[3];
extern	int	first_col[3];
extern	int	first_row[3];
extern	int	num_rec[3];
extern	int	rec_size[3];
extern	int	num_state[3];
extern	char	*dark_name[3];
extern	char	*gain_name[3];
extern	char	*limb_name[3];
#endif

