/***********************************************************
Name:
    permission.h

Purpose:
    Put machine name value into an array
    indexed by device number
    If present, device can be operated by that
    machine

Author:
    David Elmore

Date:
    Fri Jul 28 09:29:57 MDT 1995
**************************************************************/

/* Must have previously included <net.h> and <mechanism.h> */
/* KII for CHIP devices */
/* NENE for dPMon/LowK devices */
/* AKALA for mk3 devices */

#ifdef START
int permission[NUM_CMD] = {KII|AKALA|NENE,    /* GET_STATUS */
                KII|AKALA|NENE,    /* SET_OPTICS */
                KII|NENE,    /* SET_WAVE */
                KII|NENE,    /* SET_ELEMENT */
                KII|NENE,    /* DEFINE_WAVESTATE */
                KII|NENE,    /* SET_WAVESTATE */
                NENE,    /* SET_MOD */
                NENE,    /* DEFINE_MODSTATE */
                NENE    /* SET_MODATATE */
                };

int    dev_permission[NUM_DEV] = {NENE, /* FILTER_STAGE */
                NENE,    /* OD_STAGE */
                KII,    /* CHIP_COVER remove akala later*/
                KII,    /* CHIP_DIFFUSER ""*/
                KII|NENE,    /* FILTER_STROBE ""*/
                NENE,    /* MOD_STROBE */
                NENE,    /* OCCULTING_LIMITS */
                NENE,    /* COVER */
                NENE,    /* POLARIZER_STAGE */
                NENE,    /* OBJECTIVE_WHEEL */
                NENE,    /* OCCULTING_WHEEL */
                NENE,    /* FILTER_WHEEL */
                NENE    /* POLARIZER_WHEEL */
                };
#else
extern    int    permission[NUM_CMD];
extern    int    dev_permission[NUM_DEV];

#endif

