/***********************************************************
Name:
    q.h

Purpose:
    Specify all the variables needed for MCC message queues

Author:
    David Elmore

Date:
    Fri Jul 28 09:29:57 MDT 1995
**************************************************************/

#ifdef VX
#include    <vxWorks.h>
#include    <msgQLib.h>
#endif

#define    QUEUE_NUM    9    /* number of queues */
#define    QUEUE_MSGS    64    /* maximum number of messages in  a queue */
#define    QUEUE_LENGTH    80    /* allow 80 characters in a message */

/* Here are the various queues */
#define    STAT_Q    0        /* tells t_stat of device setting change */
#define    DRIVE_Q    1        /* tells t_drive to change a value */
#define    LOG_Q    2        /* a list of current status to log */
#define    DISP_Q    3        /* tells t_disp of something which changed */
#define    FILTER_Q    4        /* notifies t_filter to load new mdac values */
#define    MOD_Q    5        /* notifies t_mod to load new mdac values */
#define    REPLY_Q    6        /* notifies t_mod to load new mdac values */
#define    RECDEV_Q    7        /* notifies t_recorddevice to printout
                    new information on devices. */

#define    QTERM_Q    8        /* lets t_qterm_out know what to sent */

/* Host number in first int */
#define    HOST    0
/* Types of messages which might be found on any of the queues */
/* On command over the net this int is the command to execute */
#define    TYPE    1            
    #define    TYPE_DRIVE    0
    #define    TYPE_POS    1
    #define    TYPE_GOAL    2
    #define    TYPE_FILTER    3
    #define    TYPE_MOD    4
    #define    TYPE_ANALOG    5
    #define    TYPE_MICROMETER    6
    #define TYPE_TIMEOUT    7
    #define TYPE_MOUSE    8
    #define TYPE_DEV    9
    #define TYPE_DIR    10
    #define TYPE_QROW    11
    #define TYPE_QDEV    12
    #define TYPE_QPOS    13
    #define TYPE_QDRIVE    14
    #define TYPE_QLONG    15

/* Second int is the particular item of that type which changed */
#define    DEV        2
#define    POS        3
#define DIR        4
#define GOAL    5
#define ROW        6

#ifdef VX
    #ifdef START
    MSG_Q_ID    queue_id[QUEUE_NUM] = {0,0,0,0,0,0,0,0,0};
    #else
    extern    MSG_Q_ID    queue_id[QUEUE_NUM];
    #endif
#endif

