/***********************************************************
Name:
        screen.h
Purpose:
        Sets up row and column separation on the display
        screen.
        Defines device item and device state structures
        that hold positions and information of the device on
        the display screen.
Author:
        Alice Lecinski
Date:
        Fri Jul 28 09:29:57 MDT 1995
**************************************************************/

#define     DRDEL     200      /* DEVICE row delta (120)*/
#define     DCDEL     380      /* DEVICE column delta */
#define     DROW1  (  5  )    /* DEVICE spot for first row (50)*/
#define     DCOL1  (  100 )    /* DEVICE spot for first column */
#define     DNCOL     (4)      /* DEVICE number of columns across */

#define     ARDEL     100      /* analog row delta (120)*/
#define     ACDEL     300      /* analog column delta */
#define     AROW1  (  700 )    /* analog spot for first row (650)*/
#define     ACOL1  (  100 )    /* analog spot for first column */
#define     ANCOL     (5)      /* analog number of columns across */

#define     DX     12
#define     DY     15


struct I_item {
    char  id[40];
    char  info[40];    /* drive status as ascii */
    int   xpos, ypos;
    int   color;
    int   status;      /* drive status as an integer. */
};
struct I_state {
    char  id[40];
    int   xpos, ypos;
    int   color;
    int   highlight;
};

struct Screen_Device {
    struct I_item    trunk;
    struct I_state   Ppos[9];  /* Possible positions: see device.h */
};

struct Screen_Analog {
    struct I_item    trunk;
    struct I_state   measbox;
    float        history[200];
};


#ifdef START

struct  Screen_Device *scrn, SCREEN[NUM_DEV];
struct  Screen_Analog *anlg, ANALOG[NUM_A2D];
int    drrow[DNCOL] = {5,125,325,465};

#else

extern struct Screen_Device *scrn, SCREEN[NUM_DEV];
extern struct Screen_Analog *anlg, ANALOG[NUM_A2D];
extern int    drrow[DNCOL];

#endif

