/******************************************************************************
    Name:    
        task.h

    Purpose:
        Define task names, and priorities

    Author:
        David Elmore

    Date:
    Fri Jul 28 09:52:30 MDT 1995
******************************************************************************/
#include    <taskLib.h>

#define    TASK_NUM    12

#define    T_DISP    0
#define    T_MOUSE    1
#define    T_STAT    2
#define    T_CMD    3
#define    T_REPLY    4
#define    T_LOG    5
#define    T_ANALOG    6
#define    T_DRIVE    7
#define    T_RECANA    8  /* Record analogs */
#define    T_RECDEV    9  /* Record devices */
#define    T_QTERM_IN    10 
#define    T_QTERM_OUT    11

extern     t_disp();
extern     t_mouse();
extern     t_stat();
extern     t_cmd();
extern     t_reply();
extern     t_log();
extern     t_analog();
extern     t_drive();
extern   t_recordanalog();
extern   t_recorddevice();
extern     t_qterm_in();
extern     t_qterm_out();

#ifdef START
int    task_id[TASK_NUM]    = {0,0,0,0,0,0,0,0,0,0};
char    *task_name[TASK_NUM] = {
        "t_disp",
        "t_mouse",
        "t_stat",
        "t_cmd",
        "t_reply",
        "t_log",
        "t_analog",
        "t_drive" ,
        "t_recordanalog" ,
        "t_recorddevice",
        "t_qterm_in" ,
        "t_qterm_out" 
                };
FUNCPTR    task_addr[TASK_NUM] = {
        t_disp,
        t_mouse,
        t_stat,
        t_cmd,
        t_reply,
        t_log,
        t_analog,
        t_drive ,
        t_recordanalog ,
        t_recorddevice,
        t_qterm_in ,
        t_qterm_out
                };
int    task_pri[TASK_NUM]    =  
        {200,190,180,170,160,150,140,130,210,220,225,230};
int    start_delay[TASK_NUM] = {800,0,0,0,0,0,0,0,0,0,0,0};

#else
extern    int    task_id[TASK_NUM];
extern    char    *task_name[TASK_NUM];
extern    FUNCPTR    task_addr[TASK_NUM];
extern    int    task_pri[TASK_NUM];
extern    int    start_delay[TASK_NUM];
#endif

