#include <stdio.h>
#include <math.h>

double  xcen , ycen ;
double  pi=3.14159265358979323846 ;

double  x , y , xdis , ydis , xdissq , ydissq , radius ;


int
mkfakedisk(fimg,xdim,ydim,sunrad,inval,outval)
    float *fimg,inval,outval;
    double sunrad;
    int   xdim,ydim;
{
    register int i, j , ii ;
    register float *q ;
    int Npts;
    double sqrt() ;
    double ovsunrad;
    int doprint=0;


    if(doprint==1) 
	fprintf(stderr,
	"mkfakedisk: xdim,ydim,sunrad,inval,outval %5d %5d %.1f %.1f %.1f\n",
	xdim,ydim,sunrad,inval,outval);

    Npts=0;
    ovsunrad = 1./sunrad;

    xcen = ((double)xdim-1.)*0.5;
    ycen = ((double)ydim-1.)*0.5;
    q = fimg;
    x = y = 0 ;
    for (i=0;i<xdim*ydim; i++ ) {
	
	x = (double) (i%xdim) ;     y = (double) (i/xdim) ;

	xdis = xcen - x ;     xdissq = xdis*xdis  ;
	ydis = ycen - y ;     ydissq = ydis*ydis  ;

	radius = sqrt ( xdissq + ydissq)  * ovsunrad  ;
	if (radius<=1.){ *q = inval  ; Npts++;  }
	else           { *q = outval ;          }
	q++;
    }
    return(Npts);
}

int
s_mkfakedisk(img,xdim,ydim,sunrad,inval,outval)
    short *img,inval,outval;
    double sunrad;
    int   xdim,ydim;
{
    register int i, j , ii ;
    register short *q ;
    int Npts;
    double sqrt() ;
    double ovsunrad;

    Npts=0;
    ovsunrad = 1./sunrad;

    xcen = ((double)xdim-1.)*0.5;
    ycen = ((double)ydim-1.)*0.5;
    q = img;
    x = y = 0 ;
    for (i=0;i<xdim*ydim; i++ ) {
	
	x = (double) (i%xdim) ;     y = (double) (i/xdim) ;

	xdis = xcen - x ;     xdissq = xdis*xdis  ;
	ydis = ycen - y ;     ydissq = ydis*ydis  ;

	radius = sqrt ( xdissq + ydissq)  * ovsunrad  ;
	if (radius<=1.){ *q = inval  ; Npts++;  }
	else           { *q = outval ;          }
	q++;
    }
    return(Npts);
}
