#include                <stdio.h>
#include                <stdlib.h>
#include                <math.h>
#include                <errno.h>
#include                <fcntl.h>

#define START
#include                "dim.h"

#include                "acos.h"
#include                "acos_header.h"

#include                "params.h"

#include                "LDmodel.h"

#define SLN      120     /* string length of filenames. */


short   himg[IMSZ];

char  *ff, Hf[SLN], Cf[SLN], afile[SLN];
char  clist[SLN] , hlist[SLN];
char  ciout[SLN] , hiout[SLN];

struct acos_header   acos_h, *ah;


main(an,av) int an; char *av[];
{
    int   ii,jj,kk;
    int   Hims=0;
    int   doprint=0;
    char  *w, *ww;
    struct LDmodel_info  *LD;
    FILE  *hfid,  *hifid,*cifid;


    nrow = NROW;
    ncol = NCOL;
    imsz = IMSZ;
    im_nbytes=sizeof(short)*imsz;

    ah  = &acos_h;
    LD  = &LDmodel;
    sprintf(hlist,"hsrlist");
    sprintf(ciout,"cont_index");
    sprintf(hiout,"heli_index");

    if ( an < 1 ) { prsum() ; exit(3) ; }
 
    while (--an) { /* Read in any arguments, and the image filenames. */
        w = *++av ;
        if (*w == '?') { prsum(); exit(2); }
        if (*w == '-') { /* Check for flag arguments. */
            switch (w[1]) {
		case 'H':   --an ; w = *++av;
                            sscanf(w,"%s",hlist) ;
                            break;
                default :
                            fprintf (stderr," unknown flag %s\n",*av);
                            prsum(); exit(1);
            }
        }
    }

    if (! (hfid = fopen (hlist,"r")) ) {
        fprintf (stderr,"%s does not exist.\n",hlist); exit (1); }

    if (! (cifid = fopen (ciout,"w")) ) {
	fprintf (stderr,"%s can not be opened.\n",ciout); exit (1); }
    if (! (hifid = fopen (hiout,"w")) ) {
	fprintf (stderr,"%s can not be opened.\n",hiout); exit (1); }


    fseek(hfid,0,0);
    while(  (ii=fscanf(hfid,"%s",Hf)) == 1 ) {

        fprintf(stdout,"File: %s \n",Hf);

        readimg(Hf,himg); rereadhdr(himg,ah); 
			  extractLDinfo(himg,ah->Xdim,LD);

	fprintf(cifid,"%s %4.2f %6.3f %6.3f %10.2f %7.4f\n",
	    Hf, LD->Cp.pop_frac, LD->Cp.a, LD->Cp.b, LD->Cp.c,LD->Cp.Index);
	fprintf(hifid,"%s %4.2f %6.3f %6.3f %10.2f %7.4f\n",
	    Hf, LD->Hp.pop_frac, LD->Hp.a, LD->Hp.b, LD->Hp.c,LD->Hp.Index);

    }
    fclose(hfid);
    fclose(hifid); fclose(cifid);
}

int
prsum() {
    static char sumry[] = "\
readindx [-H hsrlist] \n\
\n\
Example: readindx\n\
\n\
Example: readindx -H hshlist.97d224 \n\
\n\
This code extracts the solar index data from calibrated helium chip images.\n\
The output files are: \"heli_index\"  and \"cont_index\" \n\
\n\
Flags    Description\n\
-----    -----------\n\
 [-H ]   The list of helium images (else the default \"hsrlist\" is used).\n\
\n\
";

    fputs (sumry,stderr);
}

int
extractLDinfo(himg,xdim,LD)  short *himg; int xdim; struct LDmodel_info *LD;
{
    short *qq;
    float *fpi, *fps;
    int ii, Nitems;

    qq  = himg + xdim;
    fps = (float *)LD ;
    fpi = (float *)qq ; 

    Nitems = sizeof(struct LDmodel_info) / sizeof(float);

    for(ii=0;ii<Nitems;ii++) *fps++ = *fpi++ ;

}
