/*
        rotate_acos -a ang infile

        Rotate a chip image by amount angle


*/


#include        <stdio.h>
#include        <stdlib.h>
#include        <errno.h>
#include        <fcntl.h>
#include        <math.h>

#define START
#include                "dim.h"
#include                "acos.h"
#include                "acos_header.h"
#include                "params.h"

struct acos_header acos_h, *ah;

double d2r =  0.01745329251994;

short   rimg[IMSZ],  img[IMSZ];

char    filenm[120], afile[120];
 
main(an,av) int an; char *av[];
{
    char      *w, *ww ;
    int       lx,ly,nx,ny;
    double    pangle_r;
    double    ang=0.,mysin,mycos,cx,cy,dx,dy,ox,oy;
    double    fx,fy,fny,fnysin,fnycos,fnx,fox,foy;
    double    rndr = 0.50005;
    register  short    *ip,*rp;
    
    int       new_angle=0;


    nrow = NROW;
    ncol = NCOL;
    imsz = IMSZ;
    im_nbytes=sizeof(short)*imsz;

    
    ah = &acos_h;
 
    if ( an <= 1 ) goto usage;

    while (--an) { /* Read in any arguments, and the image filenames. */
        w = *++av ;
        if (*w == '-') { /* Check for flag arguements. */
            switch (w[1]) {
                case 'a':   --an ; w = *++av;
                            sscanf(w,"%lf",&ang) ;
                            new_angle++;
                            break;
                default :
                            fprintf (stderr," unknown flag %s\n",*av);
                            goto usage;
            }
        }
        else {
            sprintf(filenm,"%s",w);
        }
    }

    readimg(filenm ,img);    rereadhdr(img,ah);


    dx = (double)ncol;
    dy = (double)nrow;
    cx = (dx-1.)/2.;
    cy = (dy-1.)/2.;
    
    
    ang = (new_angle) ?  ang
                      :  (double)(ah->Pangle);

    /* If the angle was the pangle, adjust to heliocentric coordinates*/
    if((is_fits==0) && (ang==ah->Pangle)) flipTB(img+ncol,ncol,nrow-1);

    pangle_r = d2r * ang ;
    mysin    = sin(pangle_r);
    mycos    = cos(pangle_r);
    
    for (ny=0; ny < nrow ; ny++) {
        fy = (double)ny;
        fny = fy-cy;
        fnysin = fny*mysin-cx;
        fnycos = fny*mycos+cy;
        for ( nx=0 ; nx < ncol ; nx++ ) {
            fx = (double)nx;
            fnx = fx-cx;
            fox = fnx*mycos-fnysin;
            foy = fnycos+fnx*mysin;
            ox = fox + rndr;
            oy = foy + rndr;
            lx = (int)ox;
            ly = (int)oy;
            rp = rimg + nx + ncol*ny;
            if ( (lx<0) || (lx >= ncol) || (ly<0) || (ly >= nrow) ) {
                *rp = 0;
            }
            else {
                ip = img + lx + ncol*ly;
                *rp = *ip;
            }
        }
    }
    
    sprintf(afile,"%s.r",filenm);
    fprintf(stderr,"New image is %s\n",afile);

    /* If the angle was the pangle, adjust to heliocentric flag. */
    if(ang==ah->Pangle) ah->Type = (ah->Type / 10) *10  + REDUCTION_h ;
    
    replacehdr(rimg,ah);
    writeimg(afile,rimg);

    exit ( 0 );
    
    usage:
	fprintf( stderr,"\trotate_acos [-a ang] filenm \n");
	fprintf( stderr,
	"\t\tIf ang is not specified, the pangle from the header\n");
	fprintf( stderr,"    will be used.\n\n");
	fprintf( stderr,"eg\trotate_acos 96d134.191422.hsr \n");
	fprintf( stderr,"eg\trotate_acos -a 90. 96d134.191422.hsr \n");
}
