#include <stdio.h>
#include <ctype.h>

#define START
#define ACOS
#include "acos.h"
#include "acos_header.h"
#include "mechanism_defs.h"
#include "device.h"
#include "analog.h"
#include "lcvr.h"
#include "mic.h"

char usage[] = "\
Gets the header of a chip file...\n\
\n\
seeheader tape_file \n";

struct acos_header acos , *a;

main (an, av) char *av[]; {
    int jj,kk;
    char *p , filenm[120] ;
    struct device *mydev;
    struct a2d    *mya2d;
    FILE *ifid;

    if ( an <= 1 ) { prsum() ; exit(-5) ;
    }

    a = &acos;

    while (--an) {
	if (*(p = *++av) == '-')		/* flag arguments */
	    switch (p[1]) {
	    default:   fprintf (stderr," unknown flag %s\n",*av);
		       prsum(); exit(1);
	    }
	else {
	    if (*p == '?') { prsum(); exit(2); }
	    sprintf(filenm,"%s",p);
	    if ((ifid = fopen (p, "r")) == NULL) {
		fprintf (stderr,"Could not open file %s\n",p);
		exit (1);
	    }
	}
    }
    fprintf(stderr,"File is %s\n",filenm);
    p= filenm+strlen(filenm) -3;
    if( *p=='f' && *(p+1)=='t' && *(p+2)=='s') { /* Fits file! */
	fseek(ifid,2880*2,0L);
    }

    if ((jj = fread (a, 1, sizeof(struct acos_header), ifid)) > 0) {
	fclose(ifid);

        fprintf(stdout,"%10d \t Version\n", a->Version );
        fprintf(stdout,"%10d \t Year\n", a->Year );
        fprintf(stdout,"%10d \t Month\n", a->Month);
        fprintf(stdout,"%10d \t Day\n", a->Day);
        fprintf(stdout,"%10d \t Hour\n", a->Hour);
        fprintf(stdout,"%10d \t Minute\n", a->Minute);
        fprintf(stdout,"%10d \t Sec\n", a->Sec);
        fprintf(stdout,"%10d \t Xdim\n", a->Xdim );
        fprintf(stdout,"%10d \t Ydim\n", a->Ydim );
        fprintf(stdout,"%10d \t Nsum\n", a->Nsum );
        fprintf(stdout,"%10d \t Exposure\n", a->Exposure );
        fprintf(stdout,"%10d \t Gain\n", a->Gain );
        fprintf(stdout,"%10d \t Odisk\n", a->Odisk );
        fprintf(stdout,"%10d \t Type\n", a->Type );
        fprintf(stdout,"%10.5g \t Wave\n", a->Wave );
        fprintf(stdout,"%10.5g \t Pangle\n", a->Pangle );
        fprintf(stdout,"%10.5g \t Bangle\n", a->Bangle );
        fprintf(stdout,"%10.5g \t Langle\n", a->Langle );
        fprintf(stdout,"%10.5g \t RA\n", a->RA );
        fprintf(stdout,"%10.5g \t Dec\n", a->Dec );
        fprintf(stdout,"%10.5g \t HA\n", a->HA );
        fprintf(stdout,"%10.5g \t Elevation\n", a->Elevation );
        fprintf(stdout,"%10.5g \t Azimuth\n", a->Azimuth );
        fprintf(stdout,"%10.5g \t Amass\n", a->Amass );
        fprintf(stdout,"%10.5g \t Radius\n", a->Radius );
        for(kk=0;kk<16;kk++)
                fprintf(stdout,"%10.5g \t Xshift[%d]\n", a->Xshift[kk] ,kk);
        for(kk=0;kk<16;kk++)
                fprintf(stdout,"%10.5g \t Yshift[%d]\n", a->Yshift[kk] ,kk);
        for(kk=0;kk<16;kk++)
                fprintf(stdout,"%10.5g \t Diam[%d]\n", a->Diam[kk] ,kk);
        for(kk=0;kk<32;kk++)
                fprintf(stdout,"%10d \t Pos[%d]\n", a->Pos[kk] ,kk);
        for(kk=0;kk<32;kk++)
                fprintf(stdout,"%10d \t Drive[%d]\n", a->Drive[kk] ,kk);
        for(kk=0;kk<16;kk++)
                fprintf(stdout,"%10.5g \t Analog[%d]\n", a->Analog[kk] ,kk);
        for(kk=0;kk<8;kk++)
                fprintf(stdout,"%10.5g \t Lcvr[%d]\n", a->Lcvr[kk] ,kk);
        for(kk=0;kk<6;kk++)
                fprintf(stdout,"%10.5g \t Mic[%d]\n", a->Mic[kk] ,kk);
	/*
        fprintf(stdout,"%s \t name[80]\n", a->name );
	*/
	fprintf(stdout,"\n");
        for(kk=0;kk<NUM_DEV;kk++) {
	    mydev = &dev[kk];
	    fprintf(stdout,"%24.24s %20.20s %20.20s\n", 
			mydev->name ,
			( a->Pos[kk] <  sizeof(mydev->stat_name)
			  &&
			  a->Pos[kk] >= 0
			)
				     ?
				     mydev->stat_name[a->Pos[kk]] 
				     :
				     "OUT OF RANGE",
			( a->Drive[kk] <  sizeof(mydev->drive_name)
			  &&
			  a->Drive[kk] >= 0
			)
				     ?
				     mydev->drive_name[a->Drive[kk]] 
				     :
				     "OUT OF RANGE"
				     );
	}
	fprintf(stdout,"\n");
        for(kk=0;kk<NUM_A2D;kk++) {
	    mya2d = &analog[kk];
	    fprintf(stdout,"%24.24s %20.4f \n", mya2d->name,a->Analog[kk]);
	}
	fprintf(stdout,"\n");
        for(kk=0;kk<NUM_LCVR;kk++) {
	    fprintf(stdout,"%24.24s %20.4f \n", lcvr_name[kk],a->Lcvr[kk]);
	}
	fprintf(stdout,"\n");
        for(kk=0;kk<NUM_MIC;kk++) {
	    fprintf(stdout,"%24.24s %20.4f \n", mic_name[kk],a->Mic[kk]);
	}
	fprintf(stdout,"\n");

   }
   else {
	fprintf(stderr,"\t\tError reading header...\n\n");
	exit (0);
   }
}
prsum () {
   fprintf (stderr,usage);
}
