#include                <stdio.h>
#include                <stdlib.h>
#include                <math.h>
#include                <errno.h>
#include                <fcntl.h>

#define START
#include                "dim.h"
#include                "shift.h"

#include                "acos.h"
#include                "acos_header.h"

#include                "params.h"

#define SLN      120        /* string length of filenames. */


short   himg[IMSZ] , *ps;
float  fhimg[IMSZ], fdimg[IMSZ];

char  *ff ;
char  Hf[SLN], afile[SLN];

struct acos_header acos_h, *ah;

main(an,av) int an; char *av[];
{
    int   ii,jj,kk;
    char  *w, *ww;
    short *ip;
    float *fp;
    float diam, xshi,yshi;

    diam=677.;

    nrow = NROW;
    ncol = NCOL;
    imsz = IMSZ;
    im_nbytes=sizeof(short)*imsz;

    ah = &acos_h;

    if ( an <= 1 ) { prsum() ; exit(3) ; }
 
    while (--an) { /* Read in any arguments, and the image filenames. */
        w = *++av ;
        if (*w == '?') { prsum(); exit(2); }
        if (*w == '-') { /* Check for flag arguments. */
            switch (w[1]) {
		default :
                            fprintf (stderr," unknown flag %s\n",*av);
                            prsum(); exit(1);
            }
	}
	else {
	    sprintf(Hf,w);
	    fprintf(stderr,"%s will be stripped.\n",Hf);
	}
    }


    readimg(Hf,himg);  rereadhdr(himg,ah); NameChip(afile,ah);

    if( ah->Version == IS_DPMON ) {
	ps = himg + ah->Xdim;
	if(     (  ah->Year == 97 && ah->Month ==  9  &&  ah->Day <= 25 )
	     || (  ah->Year == 97 && ah->Month <=  8  )
	     || (  ah->Year <  97 ) )  {
	    /*Rotate the image by 180 degrees, start past the header. */
	    rot180(ps,ah->Xdim,ah->Ydim-1);
	}
	else  {/*Flip the image top to bottom.*/
	    flipTB(ps,ah->Xdim,ah->Ydim-1);
	}

    }

    writeimg(afile,himg);
    fprintf(stderr,"Wrote data to %s\n",afile);

}
int
rot180(img,xxdim,yydim)
    short *img;
    int   xxdim,yydim;
{
    short *rimg, *qq, *rq;
    int ii, jj, Imsz;

    Imsz=xxdim*yydim;

    rimg = (short *)malloc(Imsz*sizeof(short));

    /* Rotate the image by 180 degrees. */
    qq=img; rq=rimg+Imsz-1; for(jj=0;jj<Imsz;jj++)  *rq-- = *qq++ ;

    /* Copy it back. */
    qq=img; rq=rimg;        for(jj=0;jj<Imsz;jj++)  *qq++ = *rq++ ;

    free((char *)rimg);
 
}


prsum() {
    static char help[] = "\
stripfts [file]\n\
\n\
Example:              stripfts mlso_dpmn_alr_97d015_215637.fts\n\
\n\
Flags   Description\n\
-----   -----------\n\
";
 
       fputs (help,stderr);
}
