#include                <stdio.h>
#include                <stdlib.h>
#include                <math.h>
#include                <errno.h>
#include                <fcntl.h>

#define START
#include                "dim.h"
#include                "shift.h"

#include                "acos.h"
#include                "acos_header.h"

#include                "params.h"
#include                "annuli.h"

#define SLN      120        /* string length of filenames. */


int    *pim , *hist_h;
short   himg[IMSZ],  cimg[IMSZ],  dimg[IMSZ];
float  fhimg[IMSZ], fcimg[IMSZ], fdimg[IMSZ];

char  *ff, Hf[SLN], Cf[SLN], afile[SLN];
char  clist[SLN] , hlist[SLN];

struct acos_header acos_h, *ah;


main(an,av) int an; char *av[];
{
    int   ii,jj,kk;
    int   hmin,hmax,hist_sz;
    int   Hims=0,Cims=0,mkflat=0,do_rot=0,overrideRADIUS=0;
    int   calcBCC=1,calcBCH=1;
    char  *w, *ww;
    short *ip;
    float *fp;
    float BCC,BCH;
    float Cavg,Havg,numpts,Havg_radius=0.,Cavg_radius=0.,ovnum ;
    float inval=1.,outval= -5.;
    double sunrad;
    double pi=3.14159265358979323846 ;

    FILE  *fid;

    nrow = NROW;
    ncol = NCOL;
    imsz = IMSZ;
    im_nbytes=sizeof(short)*imsz;

    ah = &acos_h;

    sprintf(Hf,"/slug/d/cordyn/CHIP/alice/97d061/97d061.193526.hsc");


	readimg(Hf,himg); rereadhdr(himg,ah);

	    zhdr(himg);
	    /*
	    z9hdr(himg); zero_shifts(himg,ah);
	    s2f(himg,fhimg);
	    */
	    if(calcBCH==1) {
		chop_bot(himg,imsz,   0);
		chop_top(himg,imsz,8192);
		hmin=array_min(himg,imsz);
		hmax=array_max(himg,imsz);
		fprintf(stdout,"hmin,hmax %d %d \n",hmin,hmax);

		hist_sz = (1+  hmax-hmin)*sizeof(int);
		hist_h=(int *)malloc(hist_sz);
		pim = hist_h; for(ii=0;ii<(1+hmax-hmin);ii++) *pim++ = 0;
		histogram(himg,hist_h,imsz,hmin);

		if ( ( fid = fopen("myhist","w") ) < (FILE*)0 ) {
		    fprintf(stderr,"Error openning myhist for writing.\n");
		    exit(-90);
		}
		if( (ii=fwrite (hist_h,1,hist_sz,fid)) != hist_sz ){
		    fprintf(stderr,"Wrote %d bytes to myhist\nExpected %d",
				    ii,hist_sz);
		    exit(-92);
		}
		fclose(fid);
            }

}

int
prsum() {
    static char sumry[] = "\
hsrMcsr [-spa] [-R radius] [-f] [-r] [-cr contref] [-li lineindex] [-H hsrlist] [-C csrlist] \n\
\n\
Example: hsrMcsr\n\
\n\
Example: hsrMcsr -cr 1620. -li 1520.1 -H hsrlist -C csrlist \n\
\n\
This code subtracts a continuum from a helium chip image using a\n\
The output files are: \"??????.dif\" \n\
If the \"-f\" flag is used, the output files are: \"??????.hsc\" \n\
\n\
Flags    Description\n\
-----    -----------\n\
 [-spa]  The data will be corrected for the pixel area of the sun.\n\
 [-f]    Flatten the images, removing rotational trends.\n\
 [-r]    Images will be rotated to *heliocentric* coordinates.\n\
 [-cr]   If specified, the contref number (else 1.0 is used).\n\
 [-li]   If specified, the lineindex number (else 1.0 is used).\n\
 [-H ]   The list of helium images (else the default \"hsrlist\" is used).\n\
 [-C ]   The list of continuum images (else the default \"csrlist\" is used).\n\
\n\
 [-R ]   The helium radius specified is used -- instead of an\n\
	 average calculated from the entire list of helium images.\n\
\n\
";

    fputs (sumry,stderr);
}

int
prhelp() {
    static char help[] = "\
hsrMcsr [-spa] [-R radius] [-f] [-r] [-cr contref] [-li lineindex] [-H hsrlist] [-C csrlist] \n\
\n\
Example: hsrMcsr\n\
\n\
Example: hsrMcsr -cr 1620. -li 1520.1 -H hsrlist -C csrlist \n\
\n\
";
    fputs (help,stderr);
}
