#include        <stdio.h>
#include        <stdlib.h>
#include        <errno.h>
#include        <fcntl.h>
#include        <math.h>

#include                "dim.h"
#include                "params.h"



int
do_rotate(img,pangle)
    short *img;
    float pangle;
{
    int       ii,lx,ly,nx,ny;
    double    pangle_r;
    double    ang,mysin,mycos,cx,cy,dx,dy,ox,oy;
    double    fx,fy,fny,fnysin,fnycos,fnx,fox,foy;
    double    rndr = 0.50005;
    double    d2r  =  0.01745329251994;
    short     *rimg;
    register  short    *ip,*rp;
    
    if(is_fits==0) {
	flipTB   (img,ncol,nrow);
    }

    rimg = (short *)malloc(ncol*nrow*sizeof(short));

    dx = (double)ncol;
    dy = (double)nrow;
    cx = (dx-1.)/2.;
    cy = (dy-1.)/2.;
    
    
    pangle_r = d2r * (double)(pangle);
    mysin = sin(pangle_r);
    mycos = cos(pangle_r);
    
    for (ny=0; ny < nrow ; ny++) {
        fy = (double)ny;
        fny = fy-cy;
        fnysin = fny*mysin-cx;
        fnycos = fny*mycos+cy;
        for ( nx=0 ; nx < ncol ; nx++ ) {
            fx = (double)nx;
            fnx = fx-cx;
            fox = fnx*mycos-fnysin;
            foy = fnycos+fnx*mysin;
            ox = fox + rndr;
            oy = foy + rndr;
            lx = (int)ox;
            ly = (int)oy;
            rp = rimg + nx + ncol*ny;
            if ( (lx<0) || (lx >= ncol) || (ly<0) || (ly >= nrow) ) {
                *rp = 0;
            }
            else {
                ip = img + lx + ncol*ly;
                *rp = *ip;
            }
        }
    }

    /* Copy it back. */
    ip=img; rp=rimg;  for(ii=0;ii<nrow*ncol;ii++)  *ip++ = *rp++ ;

    free((char *)rimg);

    
}
int
do_frotate(img,pangle)
    float *img;
    float pangle;
{
    int       ii,lx,ly,nx,ny;
    double    pangle_r;
    double    ang,mysin,mycos,cx,cy,dx,dy,ox,oy;
    double    fx,fy,fny,fnysin,fnycos,fnx,fox,foy;
    double    rndr = 0.50005;
    double    d2r  =  0.01745329251994;
    float     *rimg;
    register  float    *ip,*rp;
    
    if(is_fits==0) {
	fflipTB   (img,ncol,nrow);
    }

    rimg = (float *)malloc(ncol*nrow*sizeof(float));

    dx = (double)ncol;
    dy = (double)nrow;
    cx = (dx-1.)/2.;
    cy = (dy-1.)/2.;
    
    
    pangle_r = d2r * (double)(pangle);
    mysin = sin(pangle_r);
    mycos = cos(pangle_r);
    
    for (ny=0; ny < nrow ; ny++) {
        fy = (double)ny;
        fny = fy-cy;
        fnysin = fny*mysin-cx;
        fnycos = fny*mycos+cy;
        for ( nx=0 ; nx < ncol ; nx++ ) {
            fx = (double)nx;
            fnx = fx-cx;
            fox = fnx*mycos-fnysin;
            foy = fnycos+fnx*mysin;
            ox = fox + rndr;
            oy = foy + rndr;
            lx = (int)ox;
            ly = (int)oy;
            rp = rimg + nx + ncol*ny;
            if ( (lx<0) || (lx >= ncol) || (ly<0) || (ly >= nrow) ) {
                *rp = 0;
            }
            else {
                ip = img + lx + ncol*ly;
                *rp = *ip;
            }
        }
    }

    /* Copy it back. */
    ip=img; rp=rimg;  for(ii=0;ii<nrow*ncol;ii++)  *ip++ = *rp++ ;

    free((char *)rimg);

}
