#include                <stdio.h>
#include                <stdlib.h>
#include                <math.h>
#include                <errno.h>
#include                <fcntl.h>

#define START
#include                "dim.h"
#include                "shift.h"

#include                "acos.h"
#include                "acos_header.h"

#include                "params.h"

#define SLN      120        /* string length of filenames. */


short   himg[IMSZ],  cimg[IMSZ],  dimg[IMSZ];
float  fhimg[IMSZ], fcimg[IMSZ], fdimg[IMSZ];

char  *ff, Hf[SLN], Cf[SLN], afile[SLN];
char  clist[SLN] , hlist[SLN];

struct acos_header acos_h, *ah;


main(an,av) int an; char *av[];
{
    int   ii,jj,kk;
    int   Hims=0,Cims=0,mkflat=0,do_rot=0,overrideRADIUS=0;
    int   sunpixadj=0;
    char  *w, *ww;
    short *ip;
    float *fp;
    float lineindex=1.,contref=1.;
    float Cavg,Havg,numpts,avg_radius=0.,ovnum, sunpix ;
    float inval=1.,outval= -5.;
    short sinval=1,soutval= 0;
    double sunrad;
    double pi=3.14159265358979323846 ;

    FILE  *hfid,*cfid;

    nrow = NROW;
    ncol = NCOL;
    imsz = IMSZ;
    im_nbytes=sizeof(short)*imsz;

    ah = &acos_h;
    sprintf(clist,"csrlist");
    sprintf(hlist,"hsrlist");

    if ( an <= 1 ) { prsum() ; exit(3) ; }
 
    while (--an) { /* Read in any arguments, and the image filenames. */
        w = *++av ;
        if (*w == '?') { prsum(); exit(2); }
        if (*w == '-') { /* Check for flag arguments. */
            switch (w[1]) {
		case 'f':   mkflat=1;
                            break;
		case 'r':   do_rot=1;
                            break;
		case 'C':   --an ; w = *++av;
                            sscanf(w,"%s",clist) ;
                            break;
		case 'H':   --an ; w = *++av;
                            sscanf(w,"%s",hlist) ;
                            break;
		case 'c':   --an ; w = *++av;
                            ii = sscanf(w,"%f",&contref) ;
			    if(ii!=1){
				fprintf(stderr,
				"Incorrect contref entered:\t %s\n\n", w);
				prhelp(); exit(3);
			    }
                            break;
		case 'l':   --an ; w = *++av;
                            ii = sscanf(w,"%f",&lineindex) ;
			    if(ii!=1){
				fprintf(stderr,
				"\nIncorrect lineindex entered:\t %s\n\n", w);
				prhelp(); exit(3);
			    }
                            break;
		case 'R':   overrideRADIUS=1;
			    --an ; w = *++av;
                            sscanf(w,"%lf",&sunrad) ;
                            break;
		case 's':   sunpixadj=1;
                            break;
		default :
                            fprintf (stderr," unknown flag %s\n",*av);
                            prsum(); exit(1);
            }
	}
    }

    /* Open the file lists, count the images from csr and hsr lists
       make sure the numbers match, and save the avg_radius --
       and make the disk image  to enhance off limb features....  */

    if (! (cfid = fopen (clist,"r")) ) {
	fprintf (stderr,"%s does not exist.\n",clist);
	exit (1);
    }
    if (! (hfid = fopen (hlist,"r")) ) {
	fprintf (stderr,"%s does not exist.\n",hlist);
	exit (1);
    }
    while(  (ii=fscanf(hfid,"%s",Hf)) == 1 ) {
	Hims++;
	if( (ii=fscanf(cfid,"%s",Cf)) != 1 ) break;
	Cims++;
	readhdr(Hf,ah);
	avg_radius += ah->Radius ;  /* In arcsec */
    }
    if(Hims != Cims) {
	fprintf(stderr,
	"Number of hsr images does not equal number of csr images %d != %d \n",
	Hims,Cims);
	exit(-20);
    }
    if(overrideRADIUS==0) {
	sunrad =   (double) avg_radius 
	       / ( (double) Hims * 2.29 ) ; /* 2.29 pixels/arcsec */
    }

    sunpix = (float) ( pi*sunrad*sunrad  ) ;

    mkfakedisk(fdimg,ah->Xdim,ah->Ydim,sunrad,inval,outval);
    if(sunpixadj==1)
	s_mkfakedisk(dimg,ah->Xdim,ah->Ydim,sunrad,sinval,soutval);


    fprintf(stdout,"Made fake disk of radius %.2f pixels\n\n",sunrad);
    

    fseek(hfid,0,0);
    fseek(cfid,0,0);
    for(ii=0;ii<Hims;ii++) {
        fscanf(hfid,"%s",Hf); fscanf(cfid,"%s",Cf);
	fprintf(stdout,"Files: %s %s\n",Hf,Cf);

	readimg(Cf,cimg); rereadhdr(cimg,ah); z9hdr(cimg); zero_shifts(cimg,ah);
	    s2f(cimg,fcimg);
	    if(sunpixadj==1) { /* Only use pixels in the sun. */
		stimes(cimg,dimg);
		numpts = Cavg = 0. ; ip = cimg;
		for(jj=0;jj<imsz;jj++){
		    if( *ip != 0 ) { numpts++; Cavg += (float)*ip; }
		    ip++;
		}
	    }
	    else {
		numpts = Cavg = 0. ; fp = fcimg; ip = cimg;
		for(jj=0;jj<imsz;jj++){ 
		   if( *ip != -9999 ) { numpts++; Cavg += *fp; }
		   fp++; ip++;
		}
	    }
	    Cavg /= numpts;  Cavg = contref/Cavg;
	    fvtimes(fcimg,Cavg);

	readimg(Hf,himg); rereadhdr(himg,ah); z9hdr(himg); zero_shifts(himg,ah);
	    s2f(himg,fhimg);
	    if(sunpixadj==1) { /* Use only sun pixels. */
                stimes(himg,dimg);
                numpts = Havg = 0. ; ip = himg;
                for(jj=0;jj<imsz;jj++){
                    if( *ip != 0 ) { numpts++; Havg += (float)*ip; }
                    ip++;
                }
            }
	    else {
		numpts = Havg = 0. ; fp = fhimg; ip = himg;
		for(jj=0;jj<imsz;jj++){ 
		   if( *ip != -9999 ) { numpts++; Havg += *fp; }
		   fp++; ip++;
		}
	    }
	    Havg /= numpts;  Havg = lineindex/Havg;
	    fvtimes(fhimg,Havg);

	fminus(fhimg,fcimg);
	ftimes(fhimg,fdimg);

	if(do_rot )  do_frotate (fhimg, ah->Pangle); 
	if(mkflat)   MkFlat     (fhimg,fdimg);


	f2s(fhimg,himg);



	ah->Type            = (ah->Type / 10) *10  + REDUCTION_m ;

	if(mkflat) ah->Type = (ah->Type / 10) *10  + REDUCTION_t ;
	if(do_rot) ah->Type = (ah->Type / 10) *10  + REDUCTION_h ;

	NameChip(afile,ah);

	replacehdr(himg,ah);
	writeimg(afile,himg);

    }
    fclose(hfid);
    fclose(cfid);
}

int
prsum() {
    static char sumry[] = "\
hsrMcsr [-spa] [-R radius] [-f] [-r] [-cr contref] [-li lineindex] [-H hsrlist] [-C csrlist] \n\
\n\
Example: hsrMcsr\n\
\n\
Example: hsrMcsr -cr 1620. -li 1520.1 -H hsrlist -C csrlist \n\
\n\
This code subtracts a continuum from a helium chip image using a\n\
The output files are: \"??????.dif\" \n\
If the \"-f\" flag is used, the output files are: \"??????.hsc\" \n\
\n\
Flags    Description\n\
-----    -----------\n\
 [-spa]  The data will be corrected for the pixel area of the sun.\n\
 [-f]    Flatten the images, removing rotational trends.\n\
 [-r]    Images will be rotated to *heliocentric* coordinates.\n\
 [-cr]   If specified, the contref number (else 1.0 is used).\n\
 [-li]   If specified, the lineindex number (else 1.0 is used).\n\
 [-H ]   The list of helium images (else the default \"hsrlist\" is used).\n\
 [-C ]   The list of continuum images (else the default \"csrlist\" is used).\n\
\n\
 [-R ]   The helium radius specified is used -- instead of an\n\
	 average calculated from the entire list of helium images.\n\
\n\
";

    fputs (sumry,stderr);
}

int
prhelp() {
    static char help[] = "\
hsrMcsr [-spa] [-R radius] [-f] [-r] [-cr contref] [-li lineindex] [-H hsrlist] [-C csrlist] \n\
\n\
Example: hsrMcsr\n\
\n\
Example: hsrMcsr -cr 1620. -li 1520.1 -H hsrlist -C csrlist \n\
\n\
";
    fputs (help,stderr);
}
