/******************************************************************************
  Name:    mechanism_defs.h

  Purpose:  Define numbers for the mechanisms
        Also give definitions for bits in deive byte for devices

  Author:    David Elmore

  Date:     Mon Aug 21 13:58:07 MDT 1995

******************************************************************************/

#define    NUM_DEV    13
#define    NUM_BYTE    4

#define    FILTER_STAGE        0
#define    O2_STAGE            1    
#define    CHIP_COVER          2
#define    CHIP_DIFFUSER       3
#define    CAMERA_STROBE       4
#define    O1_E/W              5
#define    O1_N/S              6
#define    COVER               7
#define    POLARIZER_STAGE     8
#define    OBJECTIVE_WHEEL     9
#define    OCCULTING_WHEEL    10
#define    FILTER_WHEEL       11
#define    POLARIZER_WHEEL    12

#define    GENEVA_POS  0x7
#define    GENEVA_MASK  0x8

#define    COAST      0
#define    IN         1
#define    CLOSE      1
#define    O2_LOWK    1
#define    CW         1
#define    H_ALPHA    1
#define    OUT        2
#define    OPEN       2
#define    O2_DPMON   2
#define    MODULATOR  2
#define    CCW        2
#define    BRAKE      3

#define    POS_DIR    2
#define    NEG_DIR    1

/* These are types of wrap arounds */
#define    EITHER     0  /* Go either direction */
#define    NO_ZERO    1  /* Do not cross zero */
#define    POS_ONLY   2  /* Go positive direction only */
#define    TIMER      3  /* Run for time not position */

#define    POS_MASK   7  /* Some devices have 7 positoins + lock */
#define    LOCK_MASK  8  /* Lock bit here */

