/*
                normalize (img)

                img is normalized to an intensity
                level of NORM for the center BSZxBSZ pixels.

*/


#include                <stdio.h>
#include                "dim.h"


int
normalize (img)   short *img;
{
    int   ii,jj,kk,got,doprint=0;
    float rndr=0.5005;    /* Value to round up to nearest integer. */

    register float *ap;
    register short *ip;

    float  tot,ovtot;
    double ravg,sigma,ravgsq,sigmasq,npts, val, hlimit, llimit;
    double sqrt();
    int    xfirst,yfirst,xcen,ycen;

    if(doprint) fprintf(stderr,"normalize:\n");

    xcen = (ncol-1)*0.5;
    ycen = (nrow-1)*0.5;
    xfirst = xcen-FBSZ*0.5;
    yfirst = ycen-FBSZ*0.5;


	
    /*  First compute the mean and standard deviation. */

        ravg   = 0.;
        ravgsq = 0.;
	npts = FBSZ*FBSZ;
        for (jj=yfirst ;jj<yfirst+BSZ ;jj++ ) {
            ip = img + xfirst +jj*ncol;
            for (ii=0;ii<BSZ;ii++)  { ravg   += (float)*ip; 
				      ravgsq += (float)*ip * (float)*ip ;
				      ip++; }
        }
	sigmasq = ( npts*ravgsq - ravg*ravg ) / ( npts*(npts-1));
	sigma   = 2.*sqrt(sigmasq) ;
	ravg   /= (FBSZ*FBSZ) ; 
        if(doprint) fprintf ( stderr,"xm s %7.2f %7.2f  ",ravg,sigma );


    /*  Now go back through the area, and toss those points outside
        2*sigma. This is to exclude non-functioning diodes. */

	hlimit  = ravg + sigma;
	llimit  = ravg - sigma;
	tot=0.;
	npts=0.;
        for (jj=yfirst ;jj<yfirst+BSZ ;jj++ ) {
            ip = img + xfirst +jj*ncol;
            for (ii=0;ii<BSZ;ii++)  { 
		val   = (double)*ip; 
		if ((val < hlimit) && (val > llimit)) {
		    tot += val;
		    npts++;
		}
		ip++; }
        }

        ovtot = NORM*(npts)/tot;
        if(doprint) fprintf ( stderr,"Total: %7.2f  Tossed %.0f\n",
			       ovtot,FBSZ*FBSZ-npts );

    /*  Now, normalize... */

        ip = img;
        for(ii=0;ii<imsz;ii++) {
	    *ip = (short)( rndr + ((float)(*ip))*ovtot );
	    ip++; 
	}
}
