#include <stdio.h>
#include <ctype.h>

#include "acos.h"
#include "acos_header.h"

int
readhdr(filenm,ahdr) char *filenm;  struct acos_header *ahdr;
{
    register int ii;
    FILE *fid;

    if ((fid = fopen (filenm, "r")) == NULL) {
	fprintf (stderr,"Could not open file %s\n",filenm);
	exit(-99);
    }
    if ((ii = fread (ahdr, 1, sizeof(struct acos_header), fid)) <= 0) {
	fprintf (stderr,"Could not get the header from %s\n",filenm);
	exit(-99);
    }
    fclose(fid);
}

int
rereadhdr(img,ahdr) short *img;  struct acos_header *ahdr;
{
    register int ii;
    char *p, *q;

    p = (char *)ahdr;
    q = (char *)img;
    for (ii=0;ii<sizeof(struct acos_header);ii++) *p++ = *q++;
    /*
    fprintf(stderr,"Size of header is: %d\n",sizeof(struct acos_header));
    */
}

int
replacehdr(img,ahdr) short *img;  struct acos_header *ahdr;
{
    register int ii;
    char *p, *q;

    p = (char *)ahdr;
    q = (char *)img;
    for (ii=0;ii<sizeof(struct acos_header);ii++) *q++ = *p++;
}

int
zero_shifts(img,a) short *img;  struct acos_header *a;
{
    short *qq,*zq;
    int ii, jj, imsz, spot;
    int xxdim , yydim, mnYshift, mxYshift;
    int                mnXshift, mxXshift;
    int doprint = 0;
 
    xxdim = a->Xdim ;
    yydim = a->Ydim ;
    imsz = xxdim*yydim ;

    mnYshift =  500;
    mxYshift = -500;
    for(ii=0;ii<16;ii++){
	spot = (int) (a->Yshift[ii]);
	mnYshift = ( spot < mnYshift ) ? spot : mnYshift ;
	mxYshift = ( spot > mxYshift ) ? spot : mxYshift ;
    }
    if(doprint == 1)
	fprintf(stderr,"mnYshift %d mxYshift %d\n", mnYshift , mxYshift );

    if ( mxYshift >= 0 ) { /* Address the lines at the beginning of the file. */

	spot = mxYshift+3;
	qq=img;
	for (jj=0;jj<spot;jj++) {
	    zq=img+xxdim*spot;
	    for(ii=0;ii<xxdim;ii++) *qq++ = *zq++ ;
	}
    }
    if ( mnYshift <= 0 ) { /* Address the lines at the end of the file. */

	spot = -1*mnYshift    +4;
	qq=img+xxdim*(yydim-(spot-1));
	for (jj=1;jj<spot;jj++) {
	    zq=img+xxdim*(yydim-spot);
	    for(ii=0;ii<xxdim;ii++) *qq++ = *zq++ ;
	}
    }



    /* Address the Xshifts */
    mnXshift =  500;
    mxXshift = -500;
    for(ii=0;ii<16;ii++){
	spot = (int) (a->Xshift[ii]);
	mnXshift = ( spot < mnXshift ) ? spot : mnXshift ;
	mxXshift = ( spot > mxXshift ) ? spot : mxXshift ;
    }
    if(doprint == 1)
	fprintf(stderr,"mnXshift %d mxXshift %d\n", mnXshift , mxXshift );

    if ( mxXshift >= 0 ) { /* Address the lines at the beginning of the file. */
	spot = mxXshift+3;
	for (jj=0;jj<yydim;jj++) {
	    qq=img      +jj*xxdim;
	    zq=img+spot +jj*xxdim;
	    for(ii=0;ii<spot;ii++)  *qq++ = *zq ;
	    /* fprintf(stderr,"for %d *zq is %d\n",jj,*zq); */
	}
    }
    if ( mnXshift <= 0 ) { /* Address the lines at the end of the file. */
	spot = -1*mnXshift    +4;
	for (jj=1;jj<yydim;jj++) {
	    qq=img+(xxdim-(spot-1)) + jj*xxdim;
	    zq=img+(xxdim-spot)     + jj*xxdim;
	    for(ii=0;ii<spot;ii++) *qq++ = *zq ;
	}
    }


}
