/* 
 *        SendDisplayCommand
 *
 *        shift        Number of bits to right shift data
 *        buf        Buffer in which to place data
 *
 *        Send a command via the Display command queue
 *        Can be sent from the keyboard.
 *        Used by Program to automatically show images just taken.
 *        Can be used by Command in response to the user manual selection
 *        of "Display".
 *
 *        David Elmore
 *
 *        Wed Feb  2 16:21:15 GMT 1994
 */

#define         MESSAGE
#include        "message.h"


main (argc,argv)
int        argc;
char      *argv[];
{
    int                        shift;
    unsigned        int        buf;
    char                str[MSG_NBYTES];

    /*
	if ( argc < 3 )   usage();

	argv++;

	shift = strtoul(*argv++,NULL,0);
	buf   = (unsigned short)strtoul(*argv++,NULL,0);

	sprintf ( str,"%d %d",shift,buf );
    */

    sendmessage ( DISPLAY_COMMAND,str );

}

usage()
{
    fprintf(stderr,"SendDisplayCommand shift buf\n" );
    fprintf(stderr,"    shift in the range of 0-7, command as appropriate\n");
    exit(0);
}

/* 
 *        sendmessage ( key,string )
 *
 *        int        key                Message Key, see message.h
 *        char        string[25]        String to send out message queue
 *
 *        Send a message on specified queue.
 *
 *
 *        David Elmore
 *
 *        Wed Feb  2 16:21:15 GMT 1994
 */

extern                void        perror();

sendmessage        (key,string)
    key_t           key;
    char               *string;
{
    int        messagesize = MSG_NBYTES;
    int        msgflg = IPC_NOWAIT;
    int        i,rtrn;

    /* Is the queue we want not yet defined? */
    if ( (msgqid[key] = msgget (key,0)) < 0 ) {
        if ( (msgqid[key] = msgget ( key,IPC_CREAT|IPC_EXCL|0666 )) < 0 ) {
                perror("sendmessage open failure\n");
                return (-1);
	}
    }

    /* Allocate room for a message with all its baggage */
    if ( msgp <= (struct msgbuf *)0 ) {
        msgp = (struct msgbuf *)malloc((unsigned)(sizeof(struct msgbuf) 
		-
                sizeof msgp->mtext + MSG_NBYTES ));
        if ( msgp == NULL ) {
	    fprintf(stderr,"sendmessage: could not malloc %d bytes\n",
		MSG_NBYTES);
	    return (-1);
	}
    }

    for ( i=0 ; i<MSG_NBYTES ; i++ )     msgp->mtext[i] = string[i];

    /* Now send out the command */
    rtrn = msgsnd(msgqid[key],msgp,MSG_NBYTES,IPC_NOWAIT);
    if ( rtrn == -1 ) {
        perror ( "sendmessage: msgsnd failed" );
        return ( -1 );
    }

    return ( 0 );
}
