/*
		roi firstX firstY numX numY < infile > outfile

		Set environment variables XDIM and YDIM to size of input.

		firstX is first column of output
		firstY is first row of output
		numX is number of pixels per row output
		numY is number of pixels per column output

		Reads from standard input and writes to standard output.
*/

#include		<fcntl.h>
#include		<stdio.h>
#include		<stdlib.h>
#include		<errno.h>
#include		"dim.h"

main(argc,argv)
char	**argv;
int		argc;
{
char		*p;
short		*outbuf,*inbuf;
int			i,j;
register	short		*inp;
int			nrow,ncol,record;
int			firstX,firstY,numX,numY,roirec;

sscanf ( getenv ( "XDIM" ),"%d",&ncol );
sscanf ( getenv ( "YDIM" ),"%d",&nrow );
record = 2*ncol;
if ( ncol == 0 ) 
	{
	ncol = NCOL;
	nrow = NROW;
	record = RECORD;
	}

if ( argc == 5 )
	{
	p = *++argv;
		sscanf ( p,"%d",&firstX );
	p = *++argv;
		sscanf ( p,"%d",&firstY );
	p = *++argv;
		sscanf ( p,"%d",&numX );
	p = *++argv;
		sscanf ( p,"%d",&numY );
	}
else
	goto usage;


roirec = 2*numX;

inbuf = (short*)malloc ( (size_t)(2*ncol) );

/* Skip unneeded rows at top */

for ( j=0 ; j<firstY ; j++ )
	{
	if ( read ( 0,inbuf,record ) != record )
		{
		fprintf ( stderr," read error \n");
		exit ( 1 );
		}
	}

/* Read in the desired rows */

for ( j=0 ; j<numY ; j++ )
	{
	if ( read ( 0,inbuf,record ) != record )
		{
		fprintf ( stderr," read error \n");
		exit ( 1 );
		}

	inp = inbuf;
	inp += firstX;

	if ( write ( 1,inp,roirec)!= roirec )
		{
		fprintf ( stderr," write error \n");
		exit ( 1 );
		}
	}

exit ( 0 );

usage:	fprintf ( stderr,"roi firstX firstY numX numY < file > file\n" );
		exit ( 1 );
}
