/*
		scatter diam del_diam < file > scatter_file

		diam is a file containing solar diamter
		in pixels and p angle in degrees

		del_diam is a floating point constant to be added
		to the value of diam.

		file is the file for which we wantto extract the limg
		scattering level.

*/


#include		<stdio.h>
#include		<stdlib.h>
#include		<errno.h>
#include		<math.h>
#include		"dim.h"

main(argc,argv)
char		**argv;
int		argc;
{
char		*p;

FILE		*diamfile;
int			isafile,i,j,code,write();
short		*in,*img;
float		deldiam,fi,fj,pow,diam,val,x,y,xcen,ycen,rad,rvec,pangle;
float		delx,dely;
register	short	*inp,*ip;

int			nrow,ncol,record;

sscanf ( getenv ( "XDIM" ),"%d",&ncol );
sscanf ( getenv ( "YDIM" ),"%d",&nrow );
record = 2*ncol;
if ( ncol == 0 ) 
	{
	ncol = NCOL;
	nrow = NROW;
	record = RECORD;
	}

img = (short*)malloc ( (size_t)(2*ncol) );
in = (short*)malloc ( (size_t)(2*ncol) );

deldiam = 0.;
if ( argc > 1 )
	{
	p = *++argv;
	if ( ( *p != '+' ) && ( *p != '-' ) )
		{
		if ( ( diamfile = fopen ( p,"r" ) ) < (FILE *)0 )
			{
			fprintf ( stderr," open error %d %s\n",diamfile,p );
			goto usage;
			}
		if ( ( code = fscanf ( diamfile,"%f %f",&diam,&pangle ) ) < 0 )
			{
			if ( code == -1 )
				{
				fprintf ( stderr," read error %d %s\n",code,p );
				goto usage;
				}
			}
		}
	else 
		{
		sscanf ( p,"%f",&diam );
		p = *++argv;
		sscanf ( p,"%f",&pangle );
		}
	if ( argc > 2 )
		{
		p = *++argv;
		sscanf ( p,"%f",&deldiam );
		}
	}
else
	{
usage:	fprintf ( stderr,"usage: scatter diamfile arg  (arg is a file or +/-const.) < in > out \n" );
		exit ( 1 );
	}

rad = (diam+deldiam)/2.;

xcen = (ncol-1)/2.;
ycen = (nrow-1)/2.;


for ( i=0; i<nrow ; i++ )
	{
	ip = img;
	inp = in;
	if ( ( code = read ( 0,in ,record ) ) != record )
		{
		fprintf ( stderr," write error %d \n",code );
		exit ( 1 );
		}
	fi = i;
	y = (fi-ycen)/rad;
	for ( j=0 ; j<ncol ; j++ )
		{
		fj = j;
		x = (fj-xcen)/rad;
		rvec = sqrt(x*x + y*y);
		if ( rvec >= 1. )
			*ip++ = *inp++;
		else
			{
			*ip++ = 0;
			*inp++;
			}
		}
	if ( ( code = write ( 1,img,record ) ) != record )
		{
		fprintf ( stderr," write error %d \n",code );
		exit ( 1 );
		}
	}
}

