/*
        select inx iny < infile > outfile

        Specify size of input image
        a centered XDIM x YDIM image is output to stdout
        Set environment variables XDIM and YDIM to desired
        size of output.
*/

#include        <fcntl.h>
#include        <stdio.h>
#include        <stdlib.h>
#include        <errno.h>
#include        "dim.h"

main(argc,argv)
char    **argv;
int        argc;
{
    char        *p;
    short        *inbuf;
    int            nbyte,num_pad,j,i,code,incol,inrow,colskip,rowskip;
    register    short        s,*np,*fp;
    
    int            nrow,ncol,record;
    
    sscanf ( getenv ( "XDIM" ),"%d",&ncol );
    sscanf ( getenv ( "YDIM" ),"%d",&nrow );
    record = 2*ncol;
    if ( ncol == 0 ) {
        ncol = NCOL;
        nrow = NROW;
        record = RECORD;
    }
    /*fprintf ( stderr,"%d %d\n",ncol,nrow );*/
    
    
    if ( argc > 1 ) {
        p = *++argv;
        if ( (*p>='0') && (*p<='9') ) {
            sscanf ( p,"%d",&i );
            incol = i;
            colskip = (incol-ncol)/2;
        }
        else
            goto usage;
        p = *++argv;
        if ( (*p>='0') && (*p<='9') ) {
            sscanf ( p,"%d",&i );
            inrow = i;
            rowskip = (inrow-nrow)/2;
        }
        else
            goto usage;
    }
    
    else {
	usage:
	    fprintf(stderr,"usage: select incol inrow (input cols and rows)\n");
            exit ( 1 );
    }
    
    inbuf = (short*)malloc ( (size_t)(2*incol*inrow) );
    s = incol<<1;
    
    /* Skip unneeded rows at top */
    
    for ( j=0 ; j<rowskip ; j++ ) {
        if ( ( nbyte = read ( 0,inbuf,s) ) <= 0 ) {
            if ( nbyte < 0 ) {
                fprintf ( stderr,"select: read error %d\n",nbyte);
                exit ( 1 );
            }
            else
                exit (0);
        }
    }
    
    /* Read in the desired rows */
    
    for ( j=0 ; j<nrow ; j++ ) {
        if ( ( nbyte = read ( 0,inbuf,s) ) <= 0 ) {
            if ( nbyte < 0 ) {
                fprintf ( stderr,"select: read error %d \n",nbyte);
                exit ( 1 );
            }
            else
                exit (0);
        }
        np = inbuf;
        np += colskip;
        if ( ( code = write ( 1,np,record) ) != record ) {
            fprintf ( stderr," write error %d \n",code);
            exit ( 1 );
        }
    }
}
