/*
		trend diam del_diam >trend_file

		diam is a file containing an ascii floating point diameter
		or is a constant with a leading + sign.

		del_diam is a floating point constant to be added
		to the value of diam.

		This routine generates a rotation trend.
		The intensity is normalized to 8192.

*/


#include		<stdio.h>
#include		<stdlib.h>
#include		<errno.h>
#include		<math.h>
#include		"dim.h"

main(argc,argv)
char		**argv;
int		argc;
{
char		*p;

/* Determined emperically 10/16/95 DFE: approx .8 micron from Allen */
float		a = 1.10;    /* Bigger rolls up limb */
float		b = .143; 	/* Bigger puts dip in center of disk */

float		f,c;

FILE		*diamfile;
int			isafile,i,j,code,write();
short		*img;
float		deldiam,fi,fj,pow,diam,val,x,y,xcen,ycen,rad,rvec,pangle;
float		delx,dely;
register	short	*ip;

int			nrow,ncol,record;

sscanf ( getenv ( "XDIM" ),"%d",&ncol );
sscanf ( getenv ( "YDIM" ),"%d",&nrow );
record = 2*ncol;
if ( ncol == 0 ) 
	{
	ncol = NCOL;
	nrow = NROW;
	record = RECORD;
	}
img = (short*)malloc ( (size_t)(2*ncol*nrow) );
/*fprintf ( stderr,"%d %d\n",ncol,nrow );*/


c = (1. - a - b )/.306853;

deldiam = 0.;
isafile = 0;
if ( argc > 1 )
	{
	p = *++argv;
	if ( ( *p != '+' ) && ( *p != '-' ) )
		{
		isafile = 1;
		if ( ( diamfile = fopen ( p,"r" ) ) < (FILE *)0 )
			{
			fprintf ( stderr," open error %d %s\n",diamfile,p );
			goto usage;
			}
		if ( ( code = fscanf ( diamfile,"%f %f",&diam,&pangle ) ) < 0 )
			{
			if ( code == -1 )
				{
				fprintf ( stderr," read error %d %s\n",code,p );
				goto usage;
				}
			}
		}
	else 
		{
		sscanf ( p,"%f",&diam );
		p = *++argv;
		sscanf ( p,"%f",&pangle );
		}
	if ( argc > 2 )
		{
		p = *++argv;
		sscanf ( p,"%f",&deldiam );
		}
	}
else
	{
usage:	fprintf ( stderr,"usage: limb arg  (arg is a file or +/-const.)\n" );
		exit ( 1 );
	}

pangle = -.01745*pangle;
delx = cos(pangle);
dely = -sin(pangle);
rad = (diam+deldiam)/2.;

xcen = (ncol-1)/2.;
ycen = (nrow-1)/2.;

ip = img;

for ( i=0; i<nrow ; i++ )
	{
	fi = i;
	y = (fi-ycen)/rad;
	for ( j=0 ; j<ncol ; j++ )
		{
		fj = j;
		x = (fj-xcen)/rad;
		rvec = sqrt(x*x + y*y);
		if ( rvec >= 1. )
			*ip++ = 3000.;
		else
			{
			f = (float)j/xcen - 1.;
			val = delx*f*8192.;
			f = (float)i/ycen - 1.;
			val = val + dely*f*8192.;
			*ip++ = (short)val;
			}
		}
	}

if ( ( code = write ( 1,img,record*nrow ) ) != record*nrow )
	{
	fprintf ( stderr," write error %d \n",code );
	exit ( 1 );
	}
}

