/*
                accumulate filelist > accumulated_file

                This program reads a list of files
                It reads in each of these files and
                accumulates them.
                The accumulated file is sent to stdout.
*/


#include                <stdio.h>
#include                <stdlib.h>
#include                <errno.h>
#include                <fcntl.h>
#include                "dim.h"

main(argc,argv)
char                **argv;
int                argc;
{
    FILE           *accumlist;
    char           filename[80],*p;
    short          *img;
    int            fdimg,i,j,k,code,read(),write();
    float          *accum,ovnum;
    register float *ap,ftemp;
    register short *ip,stemp;
    
    int            nrow,ncol,record,im_nbytes,imsize;

    sscanf ( getenv ( "XDIM" ),"%d",&ncol );
    sscanf ( getenv ( "YDIM" ),"%d",&nrow );
    record = 2*ncol;
    if(ncol==0) {ncol=NCOL;nrow=NROW;record=RECORD;}
    imsize    = nrow*ncol;
    im_nbytes = sizeof(short)*imsize;

    img   = (short*)malloc ( (size_t)(sizeof(short)*imsize) );
    accum = (float*)malloc ( (size_t)(sizeof(float)*imsize) );
    /*fprintf ( stderr,"%d %d\n",ncol,nrow );*/
    
    if ( argc == 2 ) {
	p = *++argv;
	if ( ( accumlist = fopen ( p,"r" ) ) < (FILE*)0 ) {
	    fprintf ( stderr," open error %d %s\n",accumlist,p );
	    goto usage;
	}
    }
    else
	goto usage;
    
    /* Zero out the accum area. */
    ap = accum;   for ( i=0 ; i<imsize ; i++ )   *ap++ = 0.;
    
    /* Loop through all the files in accumlist */
    /*      open the file and sum into a float */

    for ( k=0 ; feof(accumlist) == 0 ; k++ ) {

	fscanf(accumlist,"%s\n",filename);
	fdimg = open ( filename,O_RDONLY );

	if((code=read(fdimg,img,im_nbytes))!=im_nbytes){
	    fprintf(stderr,"accumulate: read error in %s expected %d got %d\n",
		    filename,im_nbytes,code );
	    exit(1);
	}
	ip = img;
	ap = accum;
	for (i=0; i<imsize ; i++ )  {   *ap += (float)(*ip);
					ip++; 
					ap++;
	}
    }
    fclose(accumlist);

    ovnum = 1./(float)k;
    fprintf ( stderr,"%3d images \n",k );
    
    /* Normalize by the number of images read */
    ap = accum;
    ip = img;
    for (i=0; i<imsize ; i++ )      {   *ip = (short)(0.5 + (*ap)*ovnum);
				        ip++;
				        ap++;
    }
			    
    write ( 1,img,im_nbytes);
    
    exit(0);
    
    usage:
            fprintf (stderr, "accumulate filelist >accumulated_image\n" );
            exit (-1);
}
