/*
                disk del_diam shiftfile > outfile
                
                A filter to draw a disk at position given in file
                shiftfile with correction del_diam.

                shiftfile is a file containing the 
                        xshift, yshift, and diam values (floats)

*/


#include                <stdio.h>
#include                <stdlib.h>
#include                <errno.h>
#include                <math.h>
#include                "dim.h"

main(argc,argv)
char                **argv;
int                argc;
{
    FILE           *file;
    void           doshift();
    char           *p;
    short          *img;
    int            i,j,code,read(),write();
    double         deldiam,xshi,yshi,diam;
    double         rad,x,y,y2,xcen,ycen;
    register short *ip;
    
    int            nrow,ncol,record,im_nbytes,imsize;

    sscanf ( getenv ( "XDIM" ),"%d",&ncol );
    sscanf ( getenv ( "YDIM" ),"%d",&nrow );
    record = 2*ncol;
    if(ncol==0) {ncol=NCOL;nrow=NROW;record=RECORD;}
    imsize    = nrow*ncol;
    im_nbytes = sizeof(short)*imsize;

    img = (short*)malloc ( (size_t)(im_nbytes) );
    /*fprintf ( stderr,"%d %d\n",ncol,nrow );*/
    
    if ( argc == 3 ) {
	p = *++argv;
	sscanf ( p,"%lf",&deldiam);
	p = *++argv;
	fprintf ( stderr,"disk: %s %.2lf   ",p,deldiam);
	if ( ( file = fopen ( p,"r" ) ) < (FILE*)0 ) {
	    fprintf ( stderr," open error %d %s\n",file,p );
	    goto usage;
	}
	fscanf  (   file,"%lf %lf %lf", &xshi,&yshi,&diam );
	fprintf ( stderr,"shifts: %.2lf %.2lf %.2lf\n",xshi, yshi, diam );
    }
    else
	goto usage;
    
    diam = diam + deldiam;                  /* disk is too large otherwise */
    xcen = ((double)ncol-1.)*0.5 - xshi;
    ycen = ((double)nrow-1.)*0.5 - yshi;
    
    rad = diam*0.5;
    
    ip = img;
    for ( i=0; i<nrow ; i++ ) {
	y = (double)i-ycen;
	y2 = y*y;
	for ( j=0 ; j<ncol ; j++ ) {
	    x = (float)j-xcen;
	    if ( sqrt(x*x + y2) < rad )  *ip++ = 8192;
	    else                         *ip++ = 0;
	}
    }
    
    if ( ( code = write ( 1,img,im_nbytes ) ) != im_nbytes ) {
	fprintf ( stderr," write error %d \n",code );
	exit ( 1 );
    }
    
    exit ( 0 );
    
    usage:
            fprintf (stderr, "disk deldiam shiftfile out_image\n" );
            fprintf (stderr, "shift file contains xshift, yshift, and diam\n");
            fprintf (stderr, "deldiam (float) is a correction to diam.\n");
            exit (-1);
    
}
