/*
                minus arg < infile > outfile
                arg is a signed integer constant or a file name
*/

#include                <fcntl.h>
#include                <stdio.h>
#include                <stdlib.h>
#include                <errno.h>
#include                "dim.h"

main(argc,argv) char **argv; int argc;
{
    char           *p;
    int            file,isafile;
    short          *numbuf,*buf;
    int            j,i,s,code;
    register short *fs,*np,*fp;
    
    int            nrow,ncol,record,im_nbytes,imsize;

    sscanf ( getenv ( "XDIM" ),"%d",&ncol );
    sscanf ( getenv ( "YDIM" ),"%d",&nrow );
    record = 2*ncol;
    if(ncol==0) {ncol=NCOL;nrow=NROW;record=RECORD;}
    imsize    = nrow*ncol;
    im_nbytes = sizeof(short)*imsize;

    numbuf = (short*)malloc ( (size_t)(im_nbytes) );
    buf    = (short*)malloc ( (size_t)(im_nbytes) );
    
    isafile = 0;
    if ( argc > 1 ) {
        p = *++argv;
        if ( ( *p != '+' ) && ( *p != '-' ) ) {
            isafile = 1;
            if ( ( file = open ( p,O_RDWR ) ) < 0 ) {
                fprintf ( stderr," open error %d %s\n",file,p);
                goto usage;
            }
        }
        else {
            sscanf ( p,"%d",&i );
            s = i;
            np = numbuf;
            for ( i=0 ; i<imsize ; i++ )     *np++ = s;
        }
    }
    
    else {
        usage:
            fprintf(stderr,"usage: minus arg  (arg is a file or +/-const.)\n" );
            fprintf(stderr,"eg   : minus -1 < fred > fred-1 \n" );
            fprintf(stderr,"eg   : minus jane < fred > fred-jane \n" );
            exit ( 1 );
    }
    
    {
        if ( ( code = read ( 0,buf,im_nbytes ) ) != im_nbytes ) {
            if ( code == -1 ) {
                fprintf ( stderr,"minus: read error %d %s\n",code,p);
                exit ( 1 );
            }
            else if ( code == 0 )     exit ( 0 );
        }
        if ( isafile == 1 ) {
            if ( ( code = read ( file,numbuf,im_nbytes ) ) != im_nbytes ) {
                if ( code == -1 ) {
                    fprintf ( stderr,"minus: read error %d %s\n",code,p);
                    exit ( 1 );
                }
                else if ( code == 0 ) exit(0);
            }
        }

        fp = buf;
        np = numbuf;
        fs = buf;
        for ( j=0 ; j<imsize ; j++ ) { *fp++ = *fs++ - *np++; }

        if ( ( code = write ( 1,buf,im_nbytes ) ) != im_nbytes ) {
            fprintf ( stderr," write error %d %s\n",code,p);
            exit ( 1 );
        }
    }
}
