/*
        normalize arg < infile > outfile

        Normalize the center of an image to specified value

        arg is a floating point constant 
*/


#include        <stdio.h>
#include        <stdlib.h>
#include        <errno.h>
#include        <fcntl.h>
#include        "dim.h"

main(argc,argv)
char        **argv;
int        argc;
{
    char     filename[80],*p;
    int      isafile,fdimg,i,j,k,code,read(),write();
    int      xfirst,yfirst,xcen,ycen;
    short    *img;
    double   norm;
    register double   tot;
    register short    *ip,*op,stemp;
    
    int            nrow,ncol,record,im_nbytes,imsize;

    sscanf ( getenv ( "XDIM" ),"%d",&ncol );
    sscanf ( getenv ( "YDIM" ),"%d",&nrow );
    record = 2*ncol;
    if(ncol==0) {ncol=NCOL;nrow=NROW;record=RECORD;}
    imsize    = nrow*ncol;
    im_nbytes = sizeof(short)*imsize;

    /*fprintf ( stderr,"%d %d\n",ncol,nrow );*/

    img = (short*)malloc ( (size_t)(im_nbytes) );

    norm = 8192.;
    
    isafile = 0;
    if ( argc == 2 ) {
        p = *++argv;
        sscanf ( p,"%lf",&norm );
    }
    
    else {
	usage:
	    fprintf ( stderr,"usage: normalize arg  (arg is float)\n" );
            exit ( 1 );
    }
    
    xcen = (ncol-1)/2;
    ycen = (nrow-1)/2;
    xfirst = xcen-64;
    yfirst = ycen-64;
    
    code = read ( 0,img,im_nbytes);
    
    tot = 0.;
    for ( j=yfirst ; j<yfirst+128 ; j++ ) {
	ip = img + xfirst + j*ncol;
	for (i=0;i<128;i++)  { tot += (double)*ip; ip++; }
    }
    tot = norm*(128.*128.)/tot;

    ip = img;
    op = img;
    for (j=0; j<imsize ; j++ )  {  *op = (short)(((double)*ip)*tot +0.5);
				    ip++;
				    op++;
    }
			
    write ( 1,img,im_nbytes);
    
    exit ( 0 );
    
}
