/*
        rotchip angle < infile > outfile

        Rotate a chip image by amount angle
        Also fix up IDL up and down problem

        Translated from Alice's rotAimg.pro IDL program.
        DFE.

        arg is a floating point constant  or file
*/


#include        <stdio.h>
#include        <stdlib.h>
#include        <errno.h>
#include        <fcntl.h>
#include        <math.h>
#include        "dim.h"

main(argc,argv)
char        **argv;
int        argc;
{
    FILE      *angfd;
    char      *p;
    int       read(),write();
    int       lx,ly,nx,ny;
    short     *img,*rnew;
    double    ang,mysin,mycos,cx,cy,dx,dy,ox,oy;
    double    fx,fy,fny,fnysin,fnycos,fnx,fox,foy;
    double    rndr = 0.50005;
    register  short    *ip,*rp;
    
    int            nrow,ncol,record,im_nbytes,imsize;

    sscanf ( getenv ( "XDIM" ),"%d",&ncol );
    sscanf ( getenv ( "YDIM" ),"%d",&nrow );
    record = 2*ncol;
    if(ncol==0) {ncol=NCOL;nrow=NROW;record=RECORD;}
    imsize    = nrow*ncol;
    im_nbytes = sizeof(short)*imsize;

    /*fprintf ( stderr,"%d %d\n",ncol,nrow );*/

    img  = (short*)malloc ( (size_t)(im_nbytes) );
    rnew = (short*)malloc ( (size_t)(im_nbytes) );
    
    
    if ( argc == 2 ) {
        p = *++argv;
        if ( ( *p != '+' ) && ( *p != '-' ) ) {
            if ( ( angfd = fopen ( p,"r" ) ) < (FILE*)0 ) {
                fprintf ( stderr," open error %d %s\n",angfd,p);
                goto usage;
            }
            fscanf ( angfd,"%lf",&ang );
            fclose ( angfd );
        }
        else 
            sscanf ( p,"%lf",&ang );
    }
    else
        goto usage;
    
    dx = (double)ncol;
    dy = (double)nrow;
    cx = (dx-1.)/2.;
    cy = (dy-1.)/2.;
    
    read ( 0,img,im_nbytes );
    
    ang = -ang * .01745;
    mysin = sin(ang);
    mycos = cos(ang);
    
    for (ny=0; ny < nrow ; ny++) {
        fy = (double)ny;
        fny = fy-cy;
        fnysin = fny*mysin-cx;
        fnycos = fny*mycos+cy;
        for ( nx=0 ; nx < ncol ; nx++ ) {
            fx = (double)nx;
            fnx = fx-cx;
            fox = fnx*mycos-fnysin;
            foy = fnycos+fnx*mysin;
            ox = fox + rndr;
            oy = foy + rndr;
            lx = (int)ox;
            ly = (int)oy;
            rp = rnew + nx + ncol*(nrow-1-ny); /* Flip top to bottom! */
            if ( (lx<0) || (lx >= ncol) || (ly<0) || (ly >= nrow) ) {
                *rp = 0;
            }
            else {
                ip = img + lx + ncol*ly;
                *rp = *ip;
            }
        }
    }
    
    write ( 1,rnew,im_nbytes);
    
    exit ( 0 );
    
    usage:
	fprintf( stderr,"rotchip ang < infile > outfile ang is signed float\n");
	fprintf( stderr,"or file name\n" );
}
