/*
        times arg <infile > outfile
        arg is a signed integer constant or file name
        Result is divided by 8192 before being
        sent to outfile
*/

#include        <fcntl.h>
#include        <stdio.h>
#include        <stdlib.h>
#include        <errno.h>
#include        "dim.h"
main(argc,argv)
char    **argv;
int        argc;
{
    char      *p ;
    int       file,isafile,j,i,code;
    short     *buf,*numbuf;
    register  int      ltmp,ltemp;
    register  short    stemp,s,*fp,*ip,*np;
    
    int            nrow,ncol,record,im_nbytes,imsize;
    float  ovnorm;

    ovnorm = 1./8192.;

    sscanf ( getenv ( "XDIM" ),"%d",&ncol );
    sscanf ( getenv ( "YDIM" ),"%d",&nrow );
    record = 2*ncol;
    if(ncol==0) {ncol=NCOL;nrow=NROW;record=RECORD;}
    imsize    = nrow*ncol;
    im_nbytes = sizeof(short)*imsize;

    /*fprintf ( stderr,"%d %d\n",ncol,nrow );*/

    buf    = (short*)malloc ( (size_t)(im_nbytes) );
    numbuf = (short*)malloc ( (size_t)(im_nbytes) );
    
    isafile = 0;
    s = 1;
    if ( argc > 1 ) {
        p = *++argv;
        if ( ( *p != '+' ) && ( *p != '-' ) ) {
            isafile = 1;
            if ( ( file = open ( p,O_RDWR ) ) < 0 ) {
                fprintf ( stderr," open error %d %s\n",file,p );
                goto usage;
            }
        }
        else {
            sscanf ( p,"%d",&i );
            s = i;
            np = numbuf;
            for ( i=0 ; i<imsize ; i++ ) *np++ = s;
        }
    }
    
    else {
    usage:    fprintf ( stderr,"usage: times arg  (file or +/-const.)\n" );
            exit ( 1 );
    }
    
    {
        if ( ( code = read ( 0,buf,im_nbytes ) ) != im_nbytes ) {
            if ( code == -1 ) {
                fprintf ( stderr,"times: read error %d %s\n",code,p );
                exit ( 1 );
            }
        }
        if ( isafile == 1 ) {
            if ( ( code = read ( file,numbuf,im_nbytes ) ) != im_nbytes ) {
                if ( code == -1 ) {
                    fprintf ( stderr,"times: read error %d %s\n",code,p );
                    exit ( 1 );
                }
            }
        }
        fp = buf;
        ip = buf;
        np = numbuf;
        for ( j=0 ; j<imsize ; j++ ) {
            *fp++ = (short)( ( (float)(*ip) * (float)(*np) ) * ovnorm );
            ip++;
            np++;
        }
        if ( ( code = write ( 1,buf,im_nbytes ) ) != im_nbytes ) {
            fprintf ( stderr," write error %d %s\n",code,p );
            exit ( 1 );
        }
    }
}
